###################################################################################################################################
#                                                                                                                                 #
#                                                    Hello fellow developers.                                                     #
#                                                                                                                                 #
#         TDB Wizard is not encrypted at all and the code used is on display for you all to see.                                  #
#                                                                                                                                 #
#         I will NEVER encrypt this addon, and encourage all wanting to learn to look at the code and take                        #
#         what you need to progress your skills.                                                                                  #
#                                                                                                                                 #
#         I do not have any issue with my code being used in other addons If it helps you, this is what Kodi is about to me.      #
#                                                                                                                                 #
#         All I would ask is that you credit the developers who have helped with a simple CREDITS.txt file.                       #
#                                         Please enjoy my addon and I hope it helps you!                                          #
#                                                                                                                                 #                                                                                 #
###################################################################################################################################

#######################################################################
#						GET ALL DEPENDANCIES NEEDED
#######################################################################
import xbmc, xbmcaddon, xbmcgui, xbmcplugin,os,base64,sys,xbmcvfs
import common as Common
import time
import extract
import shutil
import downloader
import installer
#######################################################################
#					VERIABLES NEEDED
#######################################################################
AddonTitle="[COLOR ghostwhite]TDB[/COLOR] [COLOR lightsteelblue]Wizard[/COLOR]"
addon_id = 'plugin.video.tdbwizard'
ADDON = xbmcaddon.Addon(id=addon_id)
skin         =  xbmc.getSkinDir()
FANART = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'fanart.jpg'))
ICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon.png'))
SKIN_DIR     =  xbmc.translatePath(os.path.join('special://home/addons',skin))
BASEURL = base64.b64decode(b'aHR0cDovL3RlYW10ZGJidWlsZHMuY28udWsv')
dialog = xbmcgui.Dialog()
AdvancedSettings = xbmc.translatePath('special://userdata/advancedsettings.xml')
EXTRAS_ICON         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/extras.png'))
PLAYER_CORE   = xbmc.translatePath('special://userdata/playercorefactory.xml')
YOUTUBE_DATA  = xbmc.translatePath('special://userdata/addon_data/plugin.video.youtube')


#######################################################################
#						EXTRAS MENU
#######################################################################

def EXTRAS_MENU():

 	INTRO_ENABLE  = xbmc.translatePath(os.path.join(SKIN_DIR,'extras/tdbintro.mp4'))
	INTRO_DISABLE = xbmc.translatePath(os.path.join(SKIN_DIR,'extras/tdbintro_DISABLED.mp4'))
	PLAYER_CORE   = xbmc.translatePath('special://userdata/playercorefactory.xml')

	Common.addItem('[B][COLOR ghostwhite]SPORTS DEVIL FIX[/COLOR][/B]',BASEURL,146,EXTRAS_ICON,FANART,'')

	if os.path.isfile(INTRO_ENABLE) or os.path.isfile(INTRO_DISABLE):
 		if os.path.isfile(INTRO_ENABLE):
 			INTRO_VID = "[COLOR lime][B]ENABLED[/COLOR][/B]"
 		else:
 			INTRO_VID = "[COLOR lightskyblue][B]DISABLED[/COLOR][/B]"
 	else:
 		INTRO_VID = "[COLOR ghostwhite][B]NOT APPLICABLE[/COLOR][/B]"

 	if os.path.isfile(PLAYER_CORE):
 		PLAYER_CORE_EN_DIS = "[COLOR lime][B]ENABLED[/COLOR][/B]"
 	else:
 		PLAYER_CORE_EN_DIS = "[COLOR lightskyblue][B]DISABLED[/COLOR][/B]"

 	if not "NOT APPLICABLE" in INTRO_VID:
		Common.addItem('[B][COLOR ghostwhite]HORUS / HORUS XXL INTRO VIDEO - [/COLOR][/B]' + INTRO_VID,BASEURL,75,EXTRAS_ICON,FANART,'')
	if xbmc.getCondVisibility('system.platform.android'):
		Common.addItem('[B][COLOR ghostwhite]PLAYERCOREFACTORY.XML - [/COLOR][/B]' + PLAYER_CORE_EN_DIS,'url',110,EXTRAS_ICON,FANART,'')
	if xbmc.getCondVisibility('system.platform.windows'):
		Common.addItem('[B][COLOR ghostwhite]PLAYERCOREFACTORY.XML - [/COLOR][/B]' + PLAYER_CORE_EN_DIS,'url',115,EXTRAS_ICON,FANART,'')

	Common.addItem('[B][COLOR ghostwhite]RUYA EMPTY LIST FIX[/COLOR][/B]','url',109,EXTRAS_ICON,FANART,'')

	if os.path.exists(YOUTUBE_DATA):
		Common.addItem('[B][COLOR ghostwhite]YOUTUBE FIX[/COLOR][/B]','url',132,EXTRAS_ICON,FANART,'')


#######################################################################
#				ENABLE/DISABLE THE INTRO VIDEO FOR HORUS
#######################################################################

def HORUS_INTRO():

	INTRO_ENABLE = xbmc.translatePath(os.path.join(SKIN_DIR,'extras/tdbintro.mp4'))
	INTRO_DISABLE = xbmc.translatePath(os.path.join(SKIN_DIR,'extras/tdbintro_DISABLED.mp4'))

	if os.path.exists(INTRO_ENABLE):
		try:
			os.rename(INTRO_ENABLE, INTRO_DISABLE)
		except: pass
	else:
		try:
			os.rename(INTRO_DISABLE, INTRO_ENABLE)
		except: pass

	xbmc.executebuiltin("Container.Refresh")

#######################################################################
#				PLAYER CORE FUNCTIONS
#######################################################################

def PLAYERCORE_ANDROID():

	pass_me = 0
	if os.path.isfile(PLAYER_CORE):
		pass_me = 1
		try:
			os.remove(PLAYER_CORE)
		except: pass

	if pass_me == 0:
		name = "[COLOR white][B]playercorefactory.xml[/B][/COLOR]"
		url = BASEURL + base64.b64decode(b'a29kaS9wbGF5ZXJjb3JlZmFjdG9yeS9hbmRyb2lkLnppcA==')
		description = "NULL"
		#Check is the packages folder exists, if not create it.
		path = xbmc.translatePath(os.path.join('special://home/addons','packages'))
		if not os.path.exists(path):
			os.makedirs(path)
		buildname = name
		dp = xbmcgui.DialogProgress()
		dp.create(AddonTitle,"Downaloading the playercorefactory.xml file for","the Android OS, Please Wait......")
		buildname = "build"
		lib=os.path.join(path, buildname+'.zip')
	
		try:
			os.remove(lib)
		except:
			pass

		dialog = xbmcgui.Dialog()
		downloader.download(url, lib, dp)
		addonfolder = xbmc.translatePath(os.path.join('special://home','userdata'))
		time.sleep(2)
		dp.update(0,"","Extracting Zip Please Wait","")
		installer.unzip(lib,addonfolder,dp)
		time.sleep(1)
		try:
			os.remove(lib)
		except:
			pass

		dialog.ok(AddonTitle, "[COLOR white]playercorefactory.xml installed![/COLOR]",'',"[COLOR white]Thank you for using TDB Wizard![/COLOR]")

	xbmc.executebuiltin("Container.Refresh")

def PLAYERCORE_WINDOWS():

	pass_me = 0
	if os.path.isfile(PLAYER_CORE):
		pass_me = 1
		try:
			os.remove(PLAYER_CORE)
		except: pass

	if pass_me == 0:
		name = "[COLOR white][B]playercorefactory.xml[/B][/COLOR]"
		url = BASEURL + base64.b64decode(b'a29kaS9wbGF5ZXJjb3JlZmFjdG9yeS93aW5kb3dzLnppcA==')
		description = "NULL"
		#Check is the packages folder exists, if not create it.
		path = xbmc.translatePath(os.path.join('special://home/addons','packages'))
		if not os.path.exists(path):
			os.makedirs(path)
		buildname = name
		dp = xbmcgui.DialogProgress()
		dp.create(AddonTitle,"Downaloading the playercorefactory.xml file for","the Windows OS. Please Wait......")
		buildname = "build"
		lib=os.path.join(path, buildname+'.zip')
	
		try:
			os.remove(lib)
		except:
			pass

		dialog = xbmcgui.Dialog()
		downloader.download(url, lib, dp)
		addonfolder = xbmc.translatePath(os.path.join('special://home','userdata'))
		time.sleep(2)
		dp.update(0,"","Extracting Zip Please Wait","")
		installer.unzip(lib,addonfolder,dp)
		time.sleep(1)
		try:
			os.remove(lib)
		except:
			pass

		dialog.ok(AddonTitle, "[COLOR white]playercorefactory.xml installed![/COLOR]",'',"[COLOR white]Thank you for using TDB Wizard![/COLOR]")

	xbmc.executebuiltin("Container.Refresh")

def YOUTUBE_REMOVE():

	dialog = xbmcgui.Dialog()
	if os.path.exists(YOUTUBE_DATA):
		try:
			shutil.rmtree(YOUTUBE_DATA)
		except:
			dialog.ok(AddonTitle,"[COLOR white]There was an error removing the YouTube addon data folder. Thank you for using TDB Wizard[/COLOR]")
			sys.exit(0)
		dialog.ok(AddonTitle,"[COLOR white]The YouTube plugin should now be fixed and working correctly. Thank you for using TDB Wizard[/COLOR]")
		xbmc.executebuiltin("Container.Refresh")
		sys.exit(0)
	else:
		dialog.ok(AddonTitle,"[COLOR white]We were unable to find any YouTube data saved on your system. Thank you for using TDB Wizard[/COLOR]")
		sys.exit(0)
		
def SPORTS_DEVIL_FIX():

	SPORTS_DEVIL_FOLDER = xbmc.translatePath(os.path.join('special://home/addons','plugin.video.SportsDevil'))
	PYDEV_FOLDER = xbmc.translatePath(os.path.join('special://home/addons','script.module.pydevd'))
	REPO_FOLDER = xbmc.translatePath(os.path.join('special://home/addons','repository.teamtdb'))
	path = xbmc.translatePath(os.path.join('special://home/addons','packages'))

	choice = xbmcgui.Dialog().yesno(AddonTitle,'This option will remove all traces of Sports Devil (If Installed) and install a clean version along with the TDB Repo.','Would you like to continue?',yeslabel='[B][COLOR lime]YES[/COLOR][/B]',nolabel='[B][COLOR lightskyblue]NO[/COLOR][/B]')
	if choice == 0:
		sys.exit(1)
	dialog = xbmcgui.Dialog()
	if os.path.exists(SPORTS_DEVIL_FOLDER):
		try:
			shutil.rmtree(SPORTS_DEVIL_FOLDER)
		except: pass
	if os.path.exists(PYDEV_FOLDER):
		try:
			shutil.rmtree(PYDEV_FOLDER)
		except: pass
	purgePath = xbmc.translatePath('special://home/addons/packages')
	for root, dirs, files in os.walk(purgePath):
		file_count = 0
		file_count += len(files)
	for root, dirs, files in os.walk(purgePath):
		file_count = 0
		file_count += len(files)
		if file_count > 0:            
			for f in files:
				os.unlink(os.path.join(root, f))
			for d in dirs:
				shutil.rmtree(os.path.join(root, d))
	
	if not os.path.exists(path):
		os.makedirs(path)

	if not os.path.exists(REPO_FOLDER):
		url = base64.b64decode(b'aHR0cDovL3RkYnJlcG8uY29tL3JlcG9zaXRvcnkudGVhbXRkYi0yLjAyLnppcA==')
		dp = xbmcgui.DialogProgress()
		dp.create(AddonTitle,"","","Installing TDB Repository")
		lib=os.path.join(path, 'addon.zip')
		
		try:
			os.remove(lib)
		except:
			pass

		downloader.download(url, lib, dp)
		addonfolder = xbmc.translatePath(os.path.join('special://home','addons'))
		time.sleep(2)
		dp.update(0,"","Extracting Zip Please Wait","")
		extract.all(lib,addonfolder,dp)
		
	url = BASEURL + base64.b64decode(b'ZGVwZW5kZW5jaWVzL3Nwb3J0c2RldmlsZGVwLnppcA==')
	dp = xbmcgui.DialogProgress()
	dp.create(AddonTitle,"","","Installing Dependencies")
	lib=os.path.join(path, 'addon.zip')
		
	try:
		os.remove(lib)
	except:
		pass

	downloader.download(url, lib, dp)
	addonfolder = xbmc.translatePath(os.path.join('special://home','addons'))
	time.sleep(2)
	dp.update(0,"","Extracting Zip Please Wait","")
	extract.all(lib,addonfolder,dp)
	url = BASEURL + base64.b64decode(b'YWRkb25zL1BsdWdpbnMvcGx1Z2luLnZpZGVvLlNwb3J0c0RldmlsLnppcA==')
	dp = xbmcgui.DialogProgress()
	dp.create(AddonTitle,"","","Installing Sports Devil")
	lib=os.path.join(path, 'addon.zip')
		
	try:
		os.remove(lib)
	except:
		pass

	downloader.download(url, lib, dp)
	addonfolder = xbmc.translatePath(os.path.join('special://home','addons'))
	time.sleep(2)
	dp.update(0,"","Extracting Zip Please Wait","")
	extract.all(lib,addonfolder,dp)
	try:
		os.remove(lib)
	except:
		pass
	xbmc.executebuiltin("UpdateAddonRepos")
	xbmc.executebuiltin("UpdateLocalAddons")	

	dialog.ok(AddonTitle,"[COLOR white]The Sportd Devil plugin should now be fixed and working correctly. If you have any issues please turn AUTO UPDATE OFF on Sports Devil and run this fix again.[/COLOR]")
	sys.exit(0)
