import xbmc, xbmcaddon, xbmcgui, xbmcplugin,os,base64,sys,xbmcvfs
import urllib2,urllib
import re
import common as Common
import search

AddonTitle="[COLOR ghostwhite]TDB[/COLOR] [COLOR lightsteelblue]Wizard[/COLOR]"
addon_id = 'plugin.video.tdbwizard'
ADDON = xbmcaddon.Addon(id=addon_id)
FANART = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'resources/art/youtube.jpg'))
ICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon.png'))
SEARCH_ICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/search.png'))
YOUTUBE_ICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/youtube.png'))
BASEURL = base64.b64decode(b"aHR0cDovL3RlYW10ZGJidWlsZHMuY28udWsv")
TEAM = BASEURL + base64.b64decode(b"eW91dHViZS90ZWFtdGRiLnR4dA==")
TEAMPASS = BASEURL + base64.b64decode(b"eW91dHViZS90ZWFtdGRicGFzc3dvcmQudHh0")
YOUTUBELIST = BASEURL + base64.b64decode(b"eW91dHViZS9tYWlubGlzdC50eHQ=")
CHANNELS = BASEURL + base64.b64decode(b"eW91dHViZS9jaGFubmVscy50eHQ=")

#######################################################################
#						YOUTUBE SECTION
#######################################################################

def MAINMENU():

	link = Common.OPEN_URL(YOUTUBELIST).replace('\n','').replace('\r','')
	match = re.compile('name="(.+?)".+?rl="(.+?)"').findall(link)
	for name,url in match:
		if "channel" in name.lower():
			if "other" in name.lower():
				Common.addDir("[COLOR whitesmoke][I]" + name + " [/I][/COLOR]",url,63,YOUTUBE_ICON,FANART,'')
			else:
				Common.addDir("[COLOR smokewhite]" + name + " [/COLOR]",url,61,YOUTUBE_ICON,FANART,'')
		else:
			if "search" in name.lower():
				Common.addDir("[COLOR lightskyblue]" + name + " [/COLOR]",url,64,YOUTUBE_ICON,FANART,'')
			else:
				Common.addDir("[COLOR ghostwhite]" + name + " [/COLOR]",url,62,YOUTUBE_ICON,FANART,'')

def OTHER_CHANNELS(url):

	link = Common.OPEN_URL(url).replace('\n','').replace('\r','')
	match = re.compile('name="(.+?)".+?rl="(.+?)".+?con="(.+?)".+?anart="(.+?)"').findall(link)
	for name,url,icon,fanart in match:
		Common.addDir("[COLOR smokewhite]" + name + " [/COLOR]",url,61,icon,FANART,'')

def LOADITEM(name,url):

	tag = url
	list = Common.OPEN_URL(CHANNELS).replace('\n','').replace('\r','')
	match = re.compile('url="(.+?)"').findall(list)
	for url in match:
		link = Common.OPEN_URL(url)
		patron = "<video>(.*?)</video>"
		videos = re.findall(patron,link,re.DOTALL)
		items = []
		for video in videos:
			item = {}
			item["name"] = Common.find_single_match(video,"<name>([^<]+)</name>")
			item["url"] = base64.b64decode(b"cGx1Z2luOi8vcGx1Z2luLnZpZGVvLnlvdXR1YmUvP2FjdGlvbj1wbGF5X3ZpZGVvJnZpZGVvaWQ9")+Common.find_single_match(video,"<id>([^<]+)</id>")
			item["author"] = Common.find_single_match(video,"<author>([^<]+)</author>")
			item["iconimage"] = Common.find_single_match(video,"<iconimage>([^<]+)</iconimage>")
			item["date"] = Common.find_single_match(video,"<date>([^<]+)</date>")		
			if str(tag.lower()) in item["name"].lower():
				Common.addItem('[COLOR white]' + item["name"] + ' - ' + '[COLOR orangered] Published by ' + item["author"] + ' on ' + item["date"] + '[/COLOR]',item["url"],95,item["iconimage"],FANART,'')

def LOADLIST(name,url):

    if "search" in name.lower():
        search.YOUTUBE()
    else:
         link = Common.OPEN_URL(url)
    patron = "<video>(.*?)</video>"
    videos = re.findall(patron,link,re.DOTALL)

    items = []
    for video in videos:
        item = {}
        item["name"] = Common.find_single_match(video,"<name>([^<]+)</name>")
        item["url"] = base64.b64decode(b"cGx1Z2luOi8vcGx1Z2luLnZpZGVvLnlvdXR1YmUvP2FjdGlvbj1wbGF5X3ZpZGVvJnZpZGVvaWQ9")+Common.find_single_match(video,"<id>([^<]+)</id>")
        item["author"] = Common.find_single_match(video,"<author>([^<]+)</author>")
        item["iconimage"] = Common.find_single_match(video,"<iconimage>([^<]+)</iconimage>")
        item["date"] = Common.find_single_match(video,"<date>([^<]+)</date>")
		
        Common.addItem('[COLOR white]' + item["name"] + ' - ' + '[COLOR orangered] Published by ' + item["author"] + ' on ' + item["date"] + '[/COLOR]',item["url"],95,item["iconimage"],FANART,'')
	
def TEAMTDB():

	success = 0
	vq = Common._get_keyboard( heading="Please Enter The Team TDB Password" )
	if ( not vq ): return False, 0
	title = vq

	link = Common.OPEN_URL(TEAMPASS).replace('\n','').replace('\r','')
	match = re.compile('passkey="(.+?)"').findall(link)
	for passkey in match:
		if title==passkey:
			success = 1
	
	if success == 1:
		link = Common.OPEN_URL(TEAM)
		patron = "<video>(.*?)</video>"
		videos = re.findall(patron,link,re.DOTALL)

		items = []
		for video in videos:
			item = {}
			item["name"] = Common.find_single_match(video,"<name>([^<]+)</name>")
			item["url"] = base64.b64decode(b"cGx1Z2luOi8vcGx1Z2luLnZpZGVvLnlvdXR1YmUvP2FjdGlvbj1wbGF5X3ZpZGVvJnZpZGVvaWQ9")+Common.find_single_match(video,"<id>([^<]+)</id>")
			item["author"] = Common.find_single_match(video,"<author>([^<]+)</author>")
			item["iconimage"] = Common.find_single_match(video,"<iconimage>([^<]+)</iconimage>")
			item["date"] = Common.find_single_match(video,"<date>([^<]+)</date>")
		
			Common.addLink('[COLOR white]' + item["name"] + ' - ' + '[COLOR orangered] Published by ' + item["author"] + ' on ' + item["date"] + '[/COLOR]',item["url"],95,item["iconimage"])

	else:
		dialog = xbmcgui.Dialog()
		dialog.ok(AddonTitle, "[B]You Have Been Caught Snooping Around![/B]",'')

	