###################################################################################################################################
#                                                                                                                                 #
#                                                    Hello fellow developers.                                                     #
#                                                                                                                                 #
#         TDB Wizard is not encrypted at all and the code used is on display for you all to see.                                  #
#                                                                                                                                 #
#         I will NEVER encrypt this addon, and encourage all wanting to learn to look at the code and take                        #
#         what you need to progress your skills.                                                                                  #
#                                                                                                                                 #
#         I do not have any issue with my code being used in other addons If it helps you, this is what Kodi is about to me.      #
#                                                                                                                                 #
#         All I would ask is that you credit the developers who have helped with a simple CREDITS.txt file.                       #
#                                         Please enjoy my addon and I hope it helps you!                                          #
#                                                                                                                                 #                                                                                 #
###################################################################################################################################

#######################################################################
#						GET ALL DEPENDANCIES NEEDED
#######################################################################

import xbmc, xbmcaddon, xbmcgui, xbmcplugin,os,base64,sys,xbmcvfs
from urllib import FancyURLopener
import platform
import shutil
import urllib2,urllib
import re
import glob
import time
import errno
import socket
import json

#######################################################################
#		REQUIRES script.module.requests AS A DEPENDANCY.
#######################################################################

import requests

#######################################################################
#					LOCAL .PY DEPENDANCIES
#######################################################################
import get_addons
import vulcan
import demonstratorz
import youtube
import search
import uploadlog
import runner
import tdb
import leetv
import kodiheaven
import mystic
import doneright
import kiddo
import community
import installer
import update
import parameters
import maintenance
import plugintools
import backuprestore
import speedtest
import common as Common
import wipe
import versioncheck
import status
import extras

#######################################################################
#					VERIABLES NEEDED
#######################################################################

AddonTitle          ="[COLOR ghostwhite]TDB[/COLOR] [COLOR lightskyblue]Wizard[/COLOR]"
AddonData           = xbmc.translatePath('special://userdata/addon_data')
USERDATA            =  xbmc.translatePath(os.path.join('special://home/userdata',''))
addon_id            = 'plugin.video.tdbwizard'
ADDON               = xbmcaddon.Addon(id=addon_id)
CHANGELOG           =  xbmc.translatePath(os.path.join('special://home/addons/' + addon_id,'changelog.txt'))
WIZARD_VERSION      =  xbmc.translatePath(os.path.join('special://home/addons/' + addon_id,'version.txt'))
RESOURCES           =  xbmc.translatePath(os.path.join('special://home/addons/' + addon_id,'resources'))
NOTICE              =  xbmc.translatePath(os.path.join('special://home/addons/' + addon_id,'README/NOTICE.txt'))
DEFAULT_SETTINGS    =  xbmc.translatePath(os.path.join('special://home/addons/' + addon_id,'resources/settings_default.xml'))
ADDON_DATA          =  xbmc.translatePath(os.path.join('special://home/userdata/addon_data/' + addon_id))
TDB_SETTINGS        =  xbmc.translatePath(os.path.join('special://home/userdata/addon_data/' + addon_id,'settings.xml'))
COMMUNITY_BUILD		=  xbmc.translatePath(os.path.join('special://home/userdata/','community_build.txt'))
KEYBOARD_FILE       =  xbmc.translatePath(os.path.join('special://home/userdata/keymaps/','keyboard.xml'))
ADVANCED_SET_FILE   =  xbmc.translatePath(os.path.join('special://home/userdata/','advancedsettings.xml'))
skin                =  xbmc.getSkinDir()
string              = ""
dialog              = xbmcgui.Dialog()
THE_TIME 			= time.strftime("%H:%M %p")
THE_DATE 			= time.strftime("%A %B %d %Y")

#######################################################################
#					ADDON SETTINGS
#######################################################################

check               = plugintools.get_setting("checkupdates")
auto                = plugintools.get_setting("autoupdates")

#######################################################################
#					URLS NEEDED
#######################################################################

BASEURL             = base64.b64decode(b'aHR0cDovL3RlYW10ZGJidWlsZHMuY28udWsv')
SpeedTest           = BASEURL + base64.b64decode(b'c3BlZWR0ZXN0L3NwZWVkdGVzdC50eHQ=')
AdvancedSettings    = BASEURL + base64.b64decode(b'YWR2YW5jZWRzZXR0aW5ncy93aXphcmRfcmVsLnR4dA==')
KeymapsURL          = BASEURL + base64.b64decode(b'a2V5bWFwcy93aXphcmRfcmVsLnR4dA==')
APKS                = BASEURL + base64.b64decode(b'a29kaS9hcGtzL2Fwa2xpc3QudHh0')
WINDOWS             = BASEURL + base64.b64decode(b'a29kaS93aW5kb3dzL2xpc3QudHh0')
OSX                 = BASEURL + base64.b64decode(b'a29kaS9vc3gvbGlzdC50eHQ=')
IOS                 = BASEURL + base64.b64decode(b'a29kaS9pb3MvbGlzdC50eHQ=')
APKSLIB             = BASEURL + base64.b64decode(b'YXBrcy9hcGtsaWJsaXN0LnR4dA==')
LIB                 = BASEURL + base64.b64decode(b'bGliL2xpYmxpc3QudHh0')
TOOLS               = BASEURL + base64.b64decode(b'a29kaS90b29scy9saXN0LnR4dA==')
CONTACTS            = BASEURL + base64.b64decode(b'b3RoZXIvY29udGFjdGxpc3QudHh0')
SUPPORT             = BASEURL + base64.b64decode(b'b3RoZXIvc3VwcG9ydC50eHQ=')
CREDITS             = BASEURL + base64.b64decode(b'Y3JlZGl0cy93aXphcmQudHh0')
NEWS                = BASEURL + base64.b64decode(b'b3RoZXIvbmV3cy50eHQ=')
SERVER_CHECKER      = BASEURL + base64.b64decode(b'ZG93bi50eHQ=')
SERVER_CHECK        = BASEURL + base64.b64decode(b'Y2hlY2tlci50eHQ=')
ADD_COMMUNITY       = BASEURL + base64.b64decode(b'b3RoZXIvYWRkX2NvbW11bml0eS50eHQ=')
LATEST_WIZ_VERSION  = base64.b64decode(b'aHR0cDovL3RkYnJlcG8uY29tL2dpdC96aXBzL3BsdWdpbi52aWRlby50ZGJ3aXphcmQvdmVyc2lvbi50eHQ=')
FANRIFFIC_URL_NEW   = base64.b64decode(b'aHR0cHM6Ly9vZmZzaG9yZWdpdC5jb20vc2hhbmV5L0ZhbnJpZmZpYy93aXp3aXovcGhvb2V5dGhlbWVzLmh0bWw=')
FANRIFFIC_URL_OLD   = base64.b64decode(b'aHR0cHM6Ly9vZmZzaG9yZWdpdC5jb20vc2hhbmV5L0ZhbnJpZmZpYy93aXp3aXovcGhvb2V5dGhlbWVzb2xkLmh0bWw=')

#######################################################################
#					TDB WIZARD ICONS
#######################################################################

FANART              = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'fanart.jpg'))
ICON                = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon.png'))
LEETVICON           = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/LeeTV.png'))
ART                 = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/art/'))
TDBICON             = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon.png'))
WIZARDICON          = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/wizard.png'))
LEETVICON           = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/LeeTV.png'))
DONERIGHTICON       = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/doneright.png'))
KODIHEAVENICON      = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/kodiheaven.png'))
MYSTICICON          = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/mystic.png'))
KIDDOICON           = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/kiddo.png'))
VULCANICON          = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/vulcan.png'))
OTISICON            = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/otis.png'))
DEMOICON            = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/demonstratorz.png'))
ADVANCED_SET_ICON   = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/advanced_settings.png'))
APK_ICON            = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/apk.png'))
BACKUP_ICON         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/backup.png'))
COMMUNITY_ICON      = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/community.png'))
SETTINGS_ICON       = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/settings.png'))
SPEEDTEST_ICON      = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/speed_test.png'))
SPMC_ICON           = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/SPMC.png'))
SUPPORT_ICON        = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/support.png'))
SYSTEM_INFO_ICON    = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/system_info.png'))
TMP_ICON            = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/TMP_FILES.png'))
TOOLS_ICON          = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/tools.png'))
VIP_ICON            = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/VIP.png'))
LIB_ICON            = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/lib.png'))
YOUTUBE_ICON        = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/youtube.png'))
SEARCH_ICON         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/search.png'))
GUEST_ICON          = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/guest.png'))
SERVER_ICON         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/server.png'))
BUILD_ICON          = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/build.png'))
KODI_ICON           = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/kodi.png'))
KODI_FANART         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/kodi_fanart.png'))
SPMC_ICON           = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/SPMC.png'))
SPMC_FANART         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/SPMC_fanart.png'))
UPDATE_ICON         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/update.png'))
EXTRAS_ICON         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/extras.png'))
SPORTS_ICON         = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/sports.png'))
ERROR_ICON          = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/error.png'))
STATS_ICON          = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/stats.png'))
TWITTER_ICON        = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/twitter.png'))

#######################################################################
#					TEAM TDB VERSION CHECKERS
#######################################################################

TDB_VERSION         =  os.path.join(USERDATA,'tdb.txt')
LEETV_VERSION       =  os.path.join(USERDATA,'leetv.txt')
DONERIGHT_VERSION   =  os.path.join(USERDATA,'doneright.txt')
KH_VERSION          =  os.path.join(USERDATA,'kh.txt')
MYSTIC_VERSION      =  os.path.join(USERDATA,'mystic.txt')
KIDDO_VERSION       =  os.path.join(USERDATA,'kiddo.txt')
OTIS_VERSION        =  os.path.join(USERDATA,'otis.txt')
VULCAN_VERSION      =  os.path.join(USERDATA,'vulcan.txt')
DEMON_VERSION       =  os.path.join(USERDATA,'demonstratorz.txt')

#######################################################################
#					CUSTOM HEADER FOR SECURITY
#######################################################################

class MyOpener(FancyURLopener):
	version = base64.b64decode(b'VGhlV2l6YXJkSXNIZXJl')

#######################################################################
#			REDIRECT URLLIB COMMANDS TO MYOPENER
#######################################################################

myopener = MyOpener()
urlopen = MyOpener().open

#######################################################################
#			CREATE SETTINGS XML IF IT DOES NOT EXIST
#######################################################################

if not os.path.isfile(TDB_SETTINGS):
	if not os.path.exists(ADDON_DATA):
		os.makedirs(ADDON_DATA)
	shutil.copyfile(DEFAULT_SETTINGS, TDB_SETTINGS)

#######################################################################
#						CREATE PATH FOR BACKUPS
#######################################################################

backuprestore.check_path()

#######################################################################
#						TDB WIZARD ROOT MENU
#######################################################################

def INDEX():

	#######################################################################
	#				CHECK IF THE SERVERS ARE DOWN OR UP
	#######################################################################

	offline = 0
	try:
		f = requests.get(SERVER_CHECK)
		if not "online" in f.text:
			dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. Some functionality in the wizard may be off line but most things like maintenance should still work.[/B][/COLOR]")
			offline = 1
			server_status = "[COLOR red][B]TDB SERVERS ARE CURRENTLY OFFLINE[/COLOR][/B]"
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. Some functionality in the wizard may be off line but most things like maintenance should still work.[/B][/COLOR]")
		server_status = "[COLOR red][B]TDB SERVERS ARE CURRENTLY OFFLINE[/COLOR][/B]"

	if offline == 0:
	
		#######################################################################
		#					DISPLAY TDB MESSAGE
		#######################################################################

		if os.path.isfile(NOTICE):
			try:
				f = open(NOTICE,mode='r'); msg = f.read(); f.close()
				Common.TextBoxesPlain("%s" % msg)
				os.remove(NOTICE)
			except: pass

		#######################################################################
		#				CONTACT THE RUNNER
		#######################################################################

		runner.check()

		#######################################################################
		#	VERIABLES NEEDED IN THE LIST MENU
		#######################################################################

		pleasecheck 		= 0
		BUILD_CHECK_ERROR   = 0
		CURRENT_BUILD = "[COLOR lightskyblue]ERROR[/COLOR]"
		CURRENT_VERSION_CODE = "[COLOR lightskyblue]ERROR[/COLOR]"
		LATEST_VERSION = "[COLOR lightskyblue]ERROR[/COLOR]"

		#######################################################################
		#					FIND BUILD INFORMATION
		#######################################################################

		try:
			#Information for TDB Wizard OTA updates.
			if os.path.exists(TDB_VERSION):
				VERSIONCHECK = TDB_VERSION
				FIND_URL = BASEURL + base64.b64decode(b'YnVpbGRzL3dpemFyZC91cGRhdGVfd2l6LnR4dA==')
				checkurl = BASEURL + base64.b64decode(b'YnVpbGRzL3dpemFyZC92ZXJzaW9uX2NoZWNrLnR4dA==')
				pleasecheck = 1
			#Information for Lee TV OTA updates.
			if os.path.exists(LEETV_VERSION):
				VERSIONCHECK = LEETV_VERSION
				FIND_URL = BASEURL + base64.b64decode(b"YnVpbGRzL2xlZXR2L3VwZGF0ZV93aXoudHh0")
				checkurl = BASEURL + base64.b64decode(b"YnVpbGRzL2xlZXR2L3ZlcnNpb25fY2hlY2sudHh0")
				pleasecheck = 1
			#Information for Done Right OTA updates.
			if os.path.isfile(DONERIGHT_VERSION):
				VERSIONCHECK = DONERIGHT_VERSION
				FIND_URL = BASEURL + base64.b64decode(b"YnVpbGRzL2RvbmVyaWdodC91cGRhdGVfd2l6LnR4dA==")
				checkurl = BASEURL + base64.b64decode(b"YnVpbGRzL2RvbmVyaWdodC92ZXJzaW9uX2NoZWNrLnR4dA==")
				pleasecheck = 1
			#Information for Kodi Heaven OTA updates.
			if os.path.isfile(KH_VERSION):
				VERSIONCHECK = KH_VERSION
				FIND_URL = BASEURL + base64.b64decode(b"YnVpbGRzL2tvZGloZWF2ZW4vdXBkYXRlX3dpei50eHQ=")
				checkurl = BASEURL + base64.b64decode(b"YnVpbGRzL2tvZGloZWF2ZW4vdmVyc2lvbl9jaGVjay50eHQ=")
				pleasecheck = 1
			#Information for KIDDO OTA updates.
			if os.path.isfile(KIDDO_VERSION):
				VERSIONCHECK = KIDDO_VERSION
				FIND_URL = BASEURL + base64.b64decode(b"YnVpbGRzL2tpZGRvL3VwZGF0ZV93aXoudHh0")
				checkurl = BASEURL + base64.b64decode(b"YnVpbGRzL2tpZGRvL3ZlcnNpb25fY2hlY2sudHh0")
				pleasecheck = 1
			#Information for Vulcan OTA updates.
			if os.path.isfile(VULCAN_VERSION):
				VERSIONCHECK = VULCAN_VERSION
				FIND_URL = BASEURL + base64.b64decode(b"YnVpbGRzL3Z1bGNhbi91cGRhdGVfd2l6LnR4dA==")
				checkurl = BASEURL + base64.b64decode(b"YnVpbGRzL3Z1bGNhbi92ZXJzaW9uX2NoZWNrLnR4dA==")
				pleasecheck = 1
		except:
			pass

		try:
			if pleasecheck == 1:
				vers = open(VERSIONCHECK, "r")
				regex = re.compile(r'<build>(.+?)</build><version>(.+?)</version>')
				for line in vers:
					currversion = regex.findall(line)
					for build_name,build_version in currversion:
						CURRENT_BUILD = build_name
						CURRENT_VERSION = build_version
				req = urllib2.Request(checkurl)
				req.add_header('User-Agent',base64.b64decode(b'VGhlV2l6YXJkSXNIZXJl'))
				response = urllib2.urlopen(req)
				link=response.read()
				response.close()
				match = re.compile('<build>'+CURRENT_BUILD+'</build><version>(.+?)</version><fresh>(.+?)</fresh>').findall(link)
				for newversion,fresh in match:
					LATEST_VERSION = newversion
					if CURRENT_VERSION < LATEST_VERSION:
						CURRENT_VERSION_CODE = '[COLOR lightblue]' + CURRENT_VERSION + '[/COLOR]'
					else:
						CURRENT_VERSION_CODE = '[COLOR lightblue]' + CURRENT_VERSION + '[/COLOR]'
		except:
			CURRENT_BUILD = "[COLOR lightskyblue]ERROR[/COLOR]"
			CURRENT_VERSION_CODE = "[COLOR lightskyblue]ERROR[/COLOR]"
			LATEST_VERSION = "[COLOR lightskyblue]ERROR[/COLOR]"

		try:
			update_wiz_available = 0
			vers = open(WIZARD_VERSION, "r")
			regex = re.compile(r'<version>(.+?)</version>')
			for line in vers:
				currversion = regex.findall(line)
				for ver in currversion:
					VERSION_NUMBER = ver
			req = urllib2.Request(LATEST_WIZ_VERSION)
			req.add_header('User-Agent',base64.b64decode(b'VGhlV2l6YXJkSXNIZXJl'))
			response = urllib2.urlopen(req)
			link=response.read()
			response.close()
			match = re.compile('<version>(.+?)</version>').findall(link)
			for latver in match:
				LATEST_VERSION_NUMBER = latver
				if VERSION_NUMBER < LATEST_VERSION_NUMBER:
					update_wiz_available = 1
					VERSION_NUMBER = "[COLOR red]"+VERSION_NUMBER+"[/COLOR]"
		except:
			VERSION_NUMBER = "[COLOR red]UNABLE TO GET VERSION NUMBER[/COLOR]"

		try:
			support_name = '[COLOR orangered][B]Ticket[/B][/COLOR]'
			service_url = BASEURL + base64.b64decode(b'YXBpL2FwaV9zdXBwb3J0LnBocD9hY3Rpb249Y291bnQmYnVpbGQ9') + base64.b64encode(support_name)
			body = urllib2.urlopen(service_url).read()
		except:
			body = "[COLOR lightskyblue]ERROR[/COLOR]"

	if offline == 1:
		try:
			update_wiz_available = 0
			vers = open(WIZARD_VERSION, "r")
			regex = re.compile(r'<version>(.+?)</version>')
			for line in vers:
				currversion = regex.findall(line)
				for ver in currversion:
					VERSION_NUMBER = ver
		except:
			VERSION_NUMBER = "[COLOR red]UNABLE TO GET VERSION NUMBER[/COLOR]"

	#######################################################################
	#				MAIN MENU LIST
	#######################################################################

	if offline == 1:
		Common.addItem(server_status,BASEURL,92,ICON,FANART,'')
	Common.addItem('[COLOR ghostwhite][B]WIZARD VERSION: [/B][/COLOR][COLOR lightblue][B]' + VERSION_NUMBER + '[/B][/COLOR]',BASEURL,4,BUILD_ICON,FANART,'')
	if update_wiz_available == 1:
		Common.addItem('[COLOR red][B]VERSION ' + LATEST_VERSION_NUMBER + ' IS AVAILABLE, PLEASE UPDATE NOW![/B][/COLOR]',BASEURL,4,BUILD_ICON,FANART,'')
	if offline == 0:
		if pleasecheck == 1:
			Common.addItem('[COLOR ghostwhite][B]CURRENT BUILD: [/B][/COLOR][COLOR lightblue][B]' + CURRENT_BUILD + '[/B][/COLOR]',BASEURL,4,BUILD_ICON,FANART,'')
			Common.addItem('[COLOR ghostwhite][B]YOUR VERSION: [/B][/COLOR][B]' + CURRENT_VERSION_CODE + '[/B]',BASEURL,4,BUILD_ICON,FANART,'')
			Common.addItem('[COLOR ghostwhite][B]LATEST VERSION: [/B][/COLOR][COLOR lightblue][B]' + LATEST_VERSION + '[/B][/COLOR]',BASEURL,4,BUILD_ICON,FANART,'')
			try:
				if LATEST_VERSION > CURRENT_VERSION:
					if "ERROR" not in CURRENT_VERSION_CODE:
						Common.addItem('[COLOR ghostwhite][B]CLICK TO UPDATE ' + CURRENT_BUILD.upper() + ' NOW![/B][/COLOR]',BASEURL,33,UPDATE_ICON,FANART,'')
				else:
					Common.addItem('[COLOR ghostwhite][B]' + CURRENT_BUILD.upper() + ' IS UP TO DATE![/B][/COLOR]',BASEURL,4,UPDATE_ICON,FANART,'')
			except:
				Common.addItem('[COLOR ghostwhite][B]ERROR RETRIEVING INFORMATION[/B][/COLOR]',BASEURL,4,UPDATE_ICON,FANART,'')
		else:
			if os.path.isfile(COMMUNITY_BUILD):
				Common.addDir('[COLOR slategrey][B]CURRENT BUILD: [/COLOR][COLOR lightblue][B]COMMUNITY BUILD INSTALLED[/COLOR][/B]',BASEURL,88,BUILD_ICON,FANART,'')
	if offline == 0:
		Common.addItem("[COLOR smokewhite][B]--------------------------[/B][/COLOR]",BASEURL,79,ICON,FANART,'')
		Common.addItem('[COLOR ghostwhite][B]LATEST NEWS[/B][/COLOR]',BASEURL,106,ICON,FANART,'')
	Common.addDir('[COLOR ghostwhite][B]BACKUP [COLOR smokewhite]|[/COLOR] RESTORE[/B][/COLOR]',BASEURL,8,BACKUP_ICON,FANART,'')
	if offline == 0:	
		Common.addItem("[COLOR smokewhite][B]--------------------------[/B][/COLOR]",BASEURL,79,ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]TEAM TDB BUILDS[/B][/COLOR]',BASEURL,50,BUILD_ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]TDB ADDON INSTALLER[/B][/COLOR]',BASEURL,121,ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]FANRIFFIC THEMES[/B][/COLOR]',BASEURL,144,ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]COMMUNITY BUILDS[/B][/COLOR]',BASEURL,87,COMMUNITY_ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]SEARCH BUILDS[/B][/COLOR]',BASEURL,65,SEARCH_ICON,FANART,'')
		Common.addItem("[COLOR smokewhite][B]--------------------------[/B][/COLOR]",BASEURL,79,ICON,FANART,'')
	Common.addDir('[COLOR ghostwhite][B]MAINTENANCE TOOLS[/COLOR][/B]',BASEURL,5,TOOLS_ICON,ART+'maintwall.jpg','')
	if offline == 0:
		Common.addDir('[COLOR ghostwhite][B]EXTRAS - FIXES, TWEAKS ETC[/B][/COLOR]',BASEURL,74,EXTRAS_ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]ADVANCED SETTINGS[/B][/COLOR]',BASEURL,30,ADVANCED_SET_ICON,FANART,'')	
		Common.addDir('[COLOR ghostwhite][B]CUSTOM KEYMAPS[/B][/COLOR]',BASEURL,129,ADVANCED_SET_ICON,FANART,'')	
		Common.addDir('[COLOR ghostwhite][B]SPEED TEST[/B][/COLOR]',BASEURL,16,SPEEDTEST_ICON,FANART,'')
		Common.addItem("[COLOR smokewhite][B]--------------------------[/B][/COLOR]",BASEURL,79,ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]LATEST KODI INSTALLATION FILES[/B][/COLOR]',BASEURL,28,APK_ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]LATEST KODI LIBRTMP FILES[/B][/COLOR]',BASEURL,29,LIB_ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]MUST HAVE KODI PROGRAMS & TOOLS[/B][/COLOR]',BASEURL,46,TOOLS_ICON,FANART,'')
		Common.addItem("[COLOR smokewhite][B]--------------------------[/B][/COLOR]",BASEURL,79,ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]KODI YOUTUBE CHANNELS[/B][/COLOR]',BASEURL,60,YOUTUBE_ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]ESSENTIAL DEVELOPER TWITTER DETAILS[/B][/COLOR]',BASEURL,84,TWITTER_ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]THE DAYS SPORT LISTINGS[/B][/COLOR]',BASEURL,47,SPORTS_ICON,FANART,'')
	Common.addDir('[COLOR ghostwhite][B]SYSTEM INFORMATION[/B][/COLOR]',BASEURL,4,SYSTEM_INFO_ICON,FANART,'')
	if offline == 0:
		Common.addItem("[COLOR smokewhite][B]--------------------------[/B][/COLOR]",BASEURL,79,ICON,FANART,'')
		Common.addItem('[COLOR ghostwhite][B]HOW TO GET SUPPORT[/B][/COLOR]',BASEURL,79,SUPPORT_ICON,FANART,'')
		Common.addItem('[COLOR ghostwhite][B]RAISE A SUPPORT TICKET[/B][/COLOR]',BASEURL,118,SUPPORT_ICON,FANART,'')
		Common.addDir('[COLOR ghostwhite][B]OPEN SUPPORT TICKETS: [/COLOR][COLOR lightskyblue]' + body + '[/B][/COLOR]',BASEURL,119,SUPPORT_ICON,FANART,'')
	Common.addItem('[COLOR ghostwhite][B]TDB WIZARD CREDITS[/B][/COLOR]',BASEURL,81,SEARCH_ICON,FANART,'')
	Common.addItem('[COLOR ghostwhite][B]VIEW WIZARD CHANGELOG[/B][/COLOR]',BASEURL,80,SEARCH_ICON,FANART,'')
	Common.addItem('[COLOR ghostwhite][B]VIEW LOG FILE (ERRORS)[/B][/COLOR]',BASEURL,82,ERROR_ICON,FANART,'')
	Common.addItem('[COLOR ghostwhite][B]TDB WIZARD SETTINGS[/B][/COLOR]',BASEURL,9,SETTINGS_ICON,FANART,'')

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#						LIST OF TEAM TDB BUILD MAKERS
#######################################################################

def BUILDMENU():

	Common.addDir('[B][COLOR lightskyblue]WIZARD BUILDS[/COLOR][/B] | [COLOR white]Auto Update[/COLOR] - [COLOR lime] Yes [/COLOR]',BASEURL,50,WIZARDICON,FANART,'')
	Common.addDir('[B][COLOR lightskyblue]LEETV BUILDS[/COLOR][/B] | [COLOR white]Auto Update[/COLOR] - [COLOR lime] Yes [/COLOR]',BASEURL,51,LEETVICON,FANART,'')
	Common.addDir('[B][COLOR lightskyblue]DONE RIGHT BUILDS[/COLOR][/B] | [COLOR white]Auto Update[/COLOR] - [COLOR lightskyblue] No [/COLOR]',BASEURL,52,DONERIGHTICON,FANART,'')
	Common.addDir('[B][COLOR lightskyblue]KODI HEAVEN BUILDS[/COLOR][/B] | [COLOR white]Auto Update[/COLOR] - [COLOR lightskyblue] No [/COLOR]',BASEURL,53,KODIHEAVENICON,FANART,'')
#	Common.addDir('[B][COLOR lightskyblue]MYSTIC BUILDS[/COLOR][/B] | [COLOR white]Auto Update[/COLOR] - [COLOR lightskyblue] No [/COLOR]',BASEURL,54,MYSTICICON,FANART,'')
	Common.addDir('[B][COLOR lightskyblue]KIDDO BUILDS[/COLOR][/B] | [COLOR white]Auto Update[/COLOR] - [COLOR lightskyblue] No [/COLOR]',BASEURL,55,KIDDOICON,FANART,'')
	Common.addDir('[B][COLOR lightskyblue]VULCAN BUILDS[/COLOR][/B] | [COLOR white]Auto Update[/COLOR] - [COLOR lightskyblue] No [/COLOR]',BASEURL,56,VULCANICON,FANART,'')
#	Common.addDir('[B][COLOR lightskyblue]DEMONSTRATORZ BUILDS[/COLOR][/B] | [COLOR white]Builds Auto Update[/COLOR] - [COLOR lightskyblue] No [/COLOR]',BASEURL,57,DEMOICON,FANART,'')
#	Common.addDir('[B][COLOR lightskyblue]SEARCH BUILDS[/COLOR][/B]',BASEURL,66,SEARCH_ICON,FANART,'')

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#						MAINTENANCE MENU
#######################################################################
	
def get_size(start_path):
    total_size = 0
    for dirpath, dirnames, filenames in os.walk(start_path):
        for f in filenames:
            fp = os.path.join(dirpath, f)
            total_size += os.path.getsize(fp)
    return total_size

def convertSize(size):
   import math
   if (size == 0):
       return '[COLOR lime][B]0 MB[/COLOR][/B]'
   size_name = ("B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB")
   i = int(math.floor(math.log(size,1024)))
   p = math.pow(1024,i)
   s = round(size/p,2)
   if size_name[i] == "B":
        return '[COLOR lime][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if size_name[i] == "KB":
        return '[COLOR lime][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if size_name[i] == "GB":
        return '[COLOR lightskyblue][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if size_name[i] == "TB":
        return '[COLOR lightskyblue][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if s < 50:
        return '[COLOR lime][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if s >= 50:
        if s < 100:
            return '[COLOR orange][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if s >= 100:
        return '[COLOR lightskyblue][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'

def convertSizeInstall(size):
   import math
   if (size == 0):
       return '[COLOR lime][B]0 MB[/COLOR][/B]'
   size_name = ("B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB")
   i = int(math.floor(math.log(size,1024)))
   p = math.pow(1024,i)
   s = round(size/p,2)
   if size_name[i] == "B":
        return '[COLOR lime][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if size_name[i] == "KB":
        return '[COLOR lime][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if size_name[i] == "TB":
        return '[COLOR lightskyblue][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if s < 1000:
        return '[COLOR lime][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if s >= 1000:
        if s < 1500:
            return '[COLOR orange][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'
   if s >= 1500:
        return '[COLOR lightskyblue][B]%s %s' % (s,size_name[i]) + '[/COLOR][/B]'

def MAINTENANCE_MENU():

	HOME       =  xbmc.translatePath('special://home/')
	CACHE      =  xbmc.translatePath(os.path.join('special://home/cache',''))
	PACKAGES   =  xbmc.translatePath(os.path.join('special://home/addons','packages'))
	THUMBS     =  xbmc.translatePath(os.path.join('special://home/userdata','Thumbnails'))

	if not os.path.exists(CACHE):
		CACHE     =  xbmc.translatePath(os.path.join('special://home/temp',''))
	if not os.path.exists(PACKAGES):
		os.makedirs(PACKAGES)

	try:
		CACHE_SIZE_BYTE    = get_size(CACHE)
		PACKAGES_SIZE_BYTE = get_size(PACKAGES)
		THUMB_SIZE_BYTE    = get_size(THUMBS)
	except: pass
	
	try:
		CACHE_SIZE    = convertSize(CACHE_SIZE_BYTE)
		PACKAGES_SIZE = convertSize(PACKAGES_SIZE_BYTE)
		THUMB_SIZE    = convertSize(THUMB_SIZE_BYTE)
	except: pass
	
	startup_clean = plugintools.get_setting("acstartup")
	weekly_clean = plugintools.get_setting("clearday")

	if startup_clean == "false":
		startup_onoff = "[COLOR red][B]OFF[/COLOR][/B]"
	else:
		startup_onoff = "[COLOR lime][B]ON[/COLOR][/B]"
	if weekly_clean == "0":
		weekly_onoff = "[COLOR red][B]OFF[/COLOR][/B]"
	else:
		weekly_onoff = "[COLOR lime][B]ON[/COLOR][/B]"

	Common.addItem('[COLOR lightskyblue][B]WEEKLY AUTO CLEAN - [/B][/COLOR]' + weekly_onoff,BASEURL,113,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR lightskyblue][B]AUTO CLEAN ON KODI LAUNCH - [/B][/COLOR]' + startup_onoff,BASEURL,112,TOOLS_ICON,FANART,'')
	Common.addItem("[COLOR smokewhite][B]--------------------------[/B][/COLOR]",BASEURL,79,ICON,FANART,'')
	Common.addItem("[COLOR white][B]CACHE SIZE IS [/B][/COLOR]" + str(CACHE_SIZE),BASEURL,79,ICON,FANART,'')
	Common.addItem("[COLOR white][B]PACKAGES SIZE IS [/B][/COLOR]" + str(PACKAGES_SIZE),BASEURL,79,ICON,FANART,'')
	Common.addItem("[COLOR white][B]THUMBNAIL SIZE IS [/B][/COLOR]" + str(THUMB_SIZE),BASEURL,79,ICON,FANART,'')
	Common.addItem("[COLOR smokewhite][B]SETUP AUTO CLEAR AT SPECIFIC MB[/B][/COLOR]",BASEURL,9,ICON,FANART,'')
	Common.addItem("[COLOR lightskyblue][B]REFRESH FOLDER STATISTICS[/B][/COLOR]",BASEURL,114,ICON,FANART,'')
	Common.addItem("[COLOR smokewhite][B]--------------------------[/B][/COLOR]",BASEURL,79,ICON,FANART,'')
	Common.addItem('[COLOR white]Auto Clean Device[/COLOR]','url',31,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Clear Cache[/COLOR]','url',1,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Delete Crash Logs[/COLOR]','url',25,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Delete Thumbnails[/COLOR]','url',2,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Purge Packages[/COLOR]','url',3,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Check for Broken Repositories[/COLOR]','url',147,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Check for Broken Sources in sources.xml[/COLOR]','url',148,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Reload Skin[/COLOR]','url',124,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Update Addons and Repositories[/COLOR]','url',125,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Ruya Empty List Fix[/COLOR]','url',109,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Fix Addon Update Errors (Remove Addon Database)[/COLOR]','url',10,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Convert Physical Paths To Special[/COLOR]','url',13,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Hide All Passwords[/COLOR]','url',26,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Unhide All Passwords[/COLOR]','url',37,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Base64 - Encode | Decode[/COLOR]','url',117,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Turn Debugging On/Off[/COLOR]','url',127,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Open Addon Settings (Exodus, SALTS, Specto)[/COLOR]','url',126,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]View Current or Old Log File[/COLOR]','url',35,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Upload Log File[/COLOR]','url',36,TOOLS_ICON,FANART,'')
	Common.addItem('[COLOR white]Force Close Kodi[/COLOR]','url',86,TOOLS_ICON,FANART,'')
	Common.addDir('[B][COLOR lightskyblue]SYSTEM RESET(CAUTION)[/COLOR][/B]','url',6,TOOLS_ICON,FANART,'')

	xbmc.executebuiltin('Container.SetViewMode(50)')
	
#######################################################################
#		KEYMAPS MENU for keymap.xml FILES
#######################################################################

def KEYMAPS():

	try:
		link = Common.OPEN_URL(KeymapsURL).replace('\n','').replace('\r','')
		match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)".+?ash="(.+?)"').findall(link)
		if os.path.isfile(KEYBOARD_FILE):
			Common.addItem('[COLOR smokewhite][B]Remove Current Keymap Configuration[/B][/COLOR]',BASEURL,128,ICON,FANART,'')
		for name,url,iconimage,fanart,version,description in match:
			name = "[COLOR ghostwhite][B]" + name + "[/B][/COLOR]"
			bname = " - [COLOR lightskyblue][B][COLOR white]Downloads - [/COLOR]" + str(Common.count_advanced(name)) + "[/B][/COLOR]"
			Common.addItem(name + bname,url,130,ADVANCED_SET_ICON,FANART,description)
		Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,79,ICON,FANART,'')
		Common.addItem('[COLOR lightskyblue][B]DO YOU NEED HELP OR SUPPORT?[/B][/COLOR]',BASEURL,79,SUPPORT_ICON,FANART,'')
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#		ADVANCED SETTINGS MENU for advancedsettings.xml FILES
#######################################################################

def ADVANCEDSETTINGS():

	try:
		link = Common.OPEN_URL(AdvancedSettings).replace('\n','').replace('\r','')
		match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)".+?ash="(.+?)"').findall(link)
		if os.path.isfile(ADVANCED_SET_FILE):
			Common.addItem('[COLOR smokewhite][B]Remove Current Advanced Settings Configuration[/B][/COLOR]',BASEURL,131,ICON,FANART,'')
		for name,url,iconimage,fanart,version,description in match:
			name = "[COLOR ghostwhite][B]" + name + "[/B][/COLOR]"
			bname = " - [COLOR lightskyblue][COLOR white]Downloads - [/COLOR][B]" + str(Common.count_advanced(name)) + "[/B][/COLOR]"
			Common.addItem(name + bname,url,98,ADVANCED_SET_ICON,FANART,description)
		Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,79,ICON,FANART,'')
		Common.addItem('[COLOR lightskyblue][B]DO YOU NEED HELP OR SUPPORT?[/B][/COLOR]',BASEURL,79,SUPPORT_ICON,FANART,'')
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#				GET FANRIFFIC THEMES SKINS
#######################################################################

def FANRIFFIC_THEMES():

	link = Common.OPEN_URL(FANRIFFIC_URL_NEW).replace('\n','').replace('\r','')
	match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
	for name,url,iconimage,fanart,description in match:
		name = "[COLOR ghostwhite][B]" + name + "[/B][/COLOR]"
		Common.addItem(name,url,145,iconimage,iconimage,description)
	link = Common.OPEN_URL(FANRIFFIC_URL_OLD).replace('\n','').replace('\r','')
	match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?escription="(.+?)"').findall(link)
	for name,url,iconimage,fanart,description in match:
		name = "[COLOR ghostwhite][B]" + name + "[/B][/COLOR]"
		Common.addItem(name,url,145,iconimage,iconimage,description)

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#						SPEEDTEST LIST
#######################################################################

def SPEEDTEST():

	try:
		link = Common.OPEN_URL(SpeedTest).replace('\n','').replace('\r','')
		match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)"').findall(link)
		for name,url,iconimage,fanart,description in match:
			Common.addItem('[COLOR ghostwhite]' + name + " | " + description + '[/COLOR]',url,15,SPEEDTEST_ICON,ART+'speedfanart.jpg','')
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#						BACKUP MENU MENU
#######################################################################
	
def BACKUPMENU():

	Common.addItem('[COLOR lightskyblue][B]BACKUP OPTIONS[/B][/COLOR]','url',22,BACKUP_ICON,FANART,'')	
	Common.addItem('[COLOR white]Full Backup (All Files and Folders Included)[/COLOR]','url',69,BACKUP_ICON,FANART,'')	
	Common.addItem('[COLOR white]Backup for Builds (Exc: Thumbnails, Databases)[/COLOR]','url',70,BACKUP_ICON,FANART,'')
	Common.addItem('[COLOR white]Backup Addon Data[/COLOR]','url',108,BACKUP_ICON,FANART,'')
	Common.addItem('[COLOR white]Backup RD & Trakt Settings[/COLOR]','url',103,BACKUP_ICON,FANART,'')
	Common.addItem('[COLOR white]Backup TDB TV Guide Settings[/COLOR]','url',107,BACKUP_ICON,FANART,'')
	Common.addItem('[COLOR lightskyblue][B]RESTORE OPTIONS[/B][/COLOR]','url',22,BACKUP_ICON,FANART,'')	
	Common.addDir('[COLOR white]Restore A Full Backup[/COLOR]','url',71,BACKUP_ICON,FANART,'')
	Common.addDir('[COLOR white]Restore Addon Data[/COLOR]','url',71,BACKUP_ICON,FANART,'')
	Common.addDir('[COLOR white]Restore RD & Trakt Settings[/COLOR]','url',104,BACKUP_ICON,FANART,'')
	Common.addDir('[COLOR white]Restore TDB TV Guide Settings[/COLOR]','url',71,BACKUP_ICON,FANART,'')
	Common.addItem('[COLOR lightskyblue][B]OTHER OPTIONS[/B][/COLOR]','url',22,BACKUP_ICON,FANART,'')	
	Common.addDir('[COLOR white]Delete A Backup[/COLOR]','url',72,BACKUP_ICON,FANART,'')
	Common.addItem('[COLOR white]Delete All Backups[/COLOR]','url',73,BACKUP_ICON,FANART,'')
	Common.addItem('[COLOR white]Select Backup Location[/COLOR]','url',9,BACKUP_ICON,FANART,'')

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#					LATEST SPORTS LISTINGS
#######################################################################

def SPORT_LISTINGS():

	url = base64.b64decode(b'aHR0cDovL3d3dy53aGVyZXN0aGVtYXRjaC5jb20vdHYvaG9tZS5hc3A=')
	try:
		r = requests.get(url)
		match = re.compile('http://www\.wheresthematch\.com/fixtures/(.+?)\..+?channelid.+?">(.+?)<em class="livestream">Live Stream</em></a></span> <span class="ground">(.+?)</span>').findall(r.content)
		for game,image,name in match:
			Common.addItem('[COLOR smokewhite][B]'+image+' '+'[/COLOR][/B]- [COLOR smokewhite]'+game+' [/COLOR]','','',ICON,FANART,'')
			Common.addItem('[COLOR ghostwhite]Watch '+name+'[/COLOR]','','',ICON,FANART,'')
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#		DISPLAYS USER INFO LIKE IP ADDRESS ETC
#######################################################################

def ACCOUNT():

	#######################################################################
	#			FIND WHAT VERSION OF KODI IS RUNNING
	#######################################################################

	xbmc_version=xbmc.getInfoLabel("System.BuildVersion")
	version=float(xbmc_version[:4])

	if version >= 11.0 and version <= 11.9:
		codename = 'Eden'
	if version >= 12.0 and version <= 12.9:
		codename = 'Frodo'
	if version >= 13.0 and version <= 13.9:
		codename = 'Gotham'
	if version >= 14.0 and version <= 14.9:
		codename = 'Helix'
	if version >= 15.0 and version <= 15.9:
		codename = 'Isengard'
	if version >= 16.0 and version <= 16.9:
		codename = 'Jarvis'
	if version >= 17.0 and version <= 17.9:
		codename = 'Krypton'

	f = urllib.urlopen("http://www.canyouseeme.org/")
	html_doc = f.read()
	f.close()
	m = re.search('(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)',html_doc)
	
	s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	s.connect(("8.8.8.8", 80))

	if check=="true":
		a = "[COLOR lime]Yes[/COLOR]"
	else:
		a = "[COLOR lightskyblue]No[/COLOR]"

	Common.addItem('[COLOR ghostwhite]Version: [/COLOR][COLOR lime]%s' % version + " " + codename + "[/COLOR]",BASEURL,200,SYSTEM_INFO_ICON,FANART,'')
	Common.addItem('[COLOR ghostwhite]Check For Updates: [/COLOR]' + a,BASEURL,200,SYSTEM_INFO_ICON,FANART,'')
	Common.addItem('[COLOR ghostwhite]Local IP: [/COLOR][COLOR smokewhite]' + s.getsockname()[0] + '[/COLOR]',BASEURL,200,SYSTEM_INFO_ICON,FANART,'')
	Common.addItem('[COLOR ghostwhite]External IP: [/COLOR][COLOR smokewhite]' + m.group(0) + '[/COLOR]',BASEURL,200,SYSTEM_INFO_ICON,FANART,'')

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#		MUST HAVE KODI PROGRAMS AND TOOLS MENU
#######################################################################

def KODI_TOOLS():

	try:
		link = Common.OPEN_URL(TOOLS).replace('\n','').replace('\r','')
		match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)"').findall(link)
		for name,url,iconimage,fanart,description in match:
			Common.addItem(name,url,89,KODI_ICON,KODI_FANART,description)
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#		LIST OF LATEST KODI INSTALLATION FILES
#######################################################################

def LATEST_LIST():

	if xbmc.getCondVisibility('system.platform.windows'):
		LATEST_WINDOWS()

	if xbmc.getCondVisibility('system.platform.osx'):
		LATEST_OSX()

	if xbmc.getCondVisibility('system.platform.ios'):
		LATEST_IOS()

	if xbmc.getCondVisibility('system.platform.android'):
		LATEST_ANDROID()

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#					GETS THE WINDOWS LIST
#######################################################################

def LATEST_WINDOWS():

	if not xbmc.getCondVisibility('system.platform.windows'):
		dialog = xbmcgui.Dialog()
		dialog.ok(AddonTitle + " - Windows", "[B][COLOR smokewhite]Sorry, this function is only available for Windows devices[/COLOR][/B]",'[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')
		sys.exit(1)
	else:
		try:
			link = Common.OPEN_URL(WINDOWS).replace('\n','').replace('\r','')
			match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)"').findall(link)
			Common.addItem('[COLOR lightskyblue][B]EXE Will Be Donwloaded to [COLOR lime]special://Downloads[/COLOR] You Will Need To Manually Install From There[/B][/COLOR]',BASEURL,79,APK_ICON,FANART,'')
			Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,79,APK_ICON,FANART,'')
			for name,url,iconimage,fanart,description in match:
				Common.addItem(name,url,89,KODI_ICON,KODI_FANART,description)
		except:
			dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#					GETS THE OSX LIST
#######################################################################
			
def LATEST_OSX():

	if not xbmc.getCondVisibility('system.platform.osx'):
		dialog = xbmcgui.Dialog()
		dialog.ok(AddonTitle + " - OSX", "[B][COLOR smokewhite]Sorry, this function is only available for OSX devices[/COLOR][/B]",'[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')
		sys.exit(1)
	else:
		try:
			link = Common.OPEN_URL(OSX).replace('\n','').replace('\r','')
			match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)"').findall(link)
			Common.addItem('[COLOR lightskyblue][B].dmg Will Be Donwloaded to [COLOR lime]special://Downloads[/COLOR] You Will Need To Manually Install From There[/B][/COLOR]',BASEURL,79,APK_ICON,FANART,'')
			Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,79,APK_ICON,FANART,'')
			for name,url,iconimage,fanart,description in match:
				Common.addItem(name,url,89,KODI_ICON,KODI_FANART,description)
		except:
			dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')
			
#######################################################################
#					GETS THE IOS LIST
#######################################################################

def LATEST_IOS():

	if not xbmc.getCondVisibility('system.platform.ios'):
		dialog = xbmcgui.Dialog()
		dialog.ok(AddonTitle + " - iOS", "[B][COLOR smokewhite]Sorry, this function is only available for iOS devices[/COLOR][/B]",'[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')
		sys.exit(1)
	else:
		try:
			link = Common.OPEN_URL(IOS).replace('\n','').replace('\r','')
			match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)"').findall(link)
			Common.addItem('[COLOR lightskyblue][B].deb Will Be Donwloaded to [COLOR lime]special://Downloads[/COLOR] You Will Need To Manually Install From There[/B][/COLOR]',BASEURL,79,APK_ICON,FANART,'')
			Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,79,APK_ICON,FANART,'')
			for name,url,iconimage,fanart,description in match:
				Common.addItem(name,url,89,KODI_ICON,KODI_FANART,description)
		except:
			dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#					GETS THE ANDROID LIST
#######################################################################

def LATEST_ANDROID():

	if not xbmc.getCondVisibility('system.platform.android'):
		dialog = xbmcgui.Dialog()
		dialog.ok(AddonTitle + " - Android", "[B][COLOR smokewhite]Sorry, this function is only available for Android devices[/COLOR][/B]",'[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')
		sys.exit(1)
	else:
		try:
			link = Common.OPEN_URL(APKS).replace('\n','').replace('\r','')
			match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)"').findall(link)
			Common.addItem('[COLOR lightskyblue][B]APKS Will Be Donwloaded to [COLOR lime]/sdcard/Downloads[/COLOR] You Will Need To Manually Install From There[/B][/COLOR]',BASEURL,79,APK_ICON,FANART,'')
			Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,79,APK_ICON,FANART,'')
			Common.addDir('[COLOR lime]CLICK FOR THE LATEST SIGNED KODI/SPMC APKS WITH UP TO DATE LIB FILE INCLUDED IN APK[/COLOR]',BASEURL,32,APK_ICON,FANART,'')
			for name,url,iconimage,fanart,description in match:
				Common.addItem(name,url,91,iconimage,fanart,description)
		except:
			dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')
			
#######################################################################
#					GETS THE LATEST SIGNED APKS LIST
#######################################################################

def LATESTAPKSWITHLIB():

	try:
		link = Common.OPEN_URL(APKSLIB).replace('\n','').replace('\r','')
		match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)"').findall(link)
		Common.addItem('[COLOR lightskyblue][B]APKS Will Be Donwloaded to [COLOR lime]/sdcard/Downloads[/COLOR] You Will Need To Manually Install From There[/B][/COLOR]',BASEURL,79,APK_ICON,FANART,'')
		Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,79,APK_ICON,FANART,'')
		for name,url,iconimage,fanart,description in match:
			Common.addDir(name,url,91,iconimage,fanart,description)
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#					GETS THE LIBRTMP FILES LIST
#######################################################################

def DOWNLOADLIB():

	try:
		link = Common.OPEN_URL(LIB).replace('\n','').replace('\r','')
		match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)"').findall(link)
		Common.addItem('[COLOR lightskyblue][B]Lib Files Will Be Donwloaded to [COLOR lime]the Kodi special directory[/COLOR] You Will Need To Manually Install From There. The Windows Lib File will Auto Install[/B][/COLOR]',BASEURL,79,LIB_ICON,FANART,'')
		Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,79,LIB_ICON,FANART,'')
		for name,url,iconimage,fanart,description in match:
			Common.addDir(name,url,94,LIB_ICON,fanart,description)
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#					ESSENTIAL CONTACTS LIST
#######################################################################

def KODI_CONTACTS():

	try:
		link = Common.OPEN_URL(CONTACTS)
		patron = "<video>(.*?)</video>"
		videos = re.findall(patron,link,re.DOTALL)
		items = []
		for video in videos:
			item = {}
			item["name"] = Common.find_single_match(video,"<name>([^<]+)</name>")
			item["url"] = Common.find_single_match(video,"<url>([^<]+)</url>")
			item["description"] = Common.find_single_match(video,"<description>([^<]+)</description>")

			if "NULL" in item["description"]:
				Common.addItem(item["name"] + '[COLOR white]@[/COLOR][COLOR smokewhite]' + item["url"] + '[/COLOR]',BASEURL,666,ICON,FANART,'')
			else:
				Common.addDir(item["name"] + '[COLOR white]@[/COLOR][COLOR smokewhite]' + item["url"] + '[/COLOR]',BASEURL,102,ICON,FANART,item["description"])
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

	xbmc.executebuiltin('Container.SetViewMode(50)')

#######################################################################
#					VIEW CHANGELOG
#######################################################################

def VIEW_CHANGELOG():

	f = open(CHANGELOG,mode='r'); msg = f.read(); f.close()
	Common.TextBoxesPlain("%s" % msg)

#######################################################################
#					HOW TO GET SUPPORT
#######################################################################

def GET_SUPPORT():

	try:
		f = requests.get(SUPPORT)
		Common.TextBoxesPlain("%s" % f.text)
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

#######################################################################
#					LATEST TDB NEWS
#######################################################################

def ADD_COMMUNITY_BUILD():

	try:
		f = requests.get(ADD_COMMUNITY)
		Common.TextBoxesPlain("%s" % f.text)
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

#######################################################################
#					LATEST TDB NEWS
#######################################################################

def LATEST_NEWS():

	try:
		f = requests.get(NEWS)
		Common.TextBoxesPlain("%s" % f.text)
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

#######################################################################
#					TDB WIZARD CREDITS
#######################################################################

def VIEW_CREDITS():

	try:
		f = requests.get(CREDITS)
		Common.TextBoxesPlain("%s" % f.text)
	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. This is a temporary issue, please try again later..[/B][/COLOR]")

#######################################################################
#					REMOVE KEYBOARD.XML FILE
#######################################################################

def REMOVE_KEYBOARD_FILE():

	try:
		os.remove(KEYBOARD_FILE)
	except:
		dialog.ok(AddonTitle, "[B][COLOR white]Sorry, TDB Wizard encountered an error[/COLOR][/B]",'[COLOR white]We were unable to remove the keyboard.xml file.[/COLOR]')
		sys.exit(0)
		
	dialog.ok(AddonTitle, "[B][COLOR white]Success, we have removed the keyboards.xml file.[/COLOR][/B]",'[COLOR white]Thank you for using TDB Wizard[/COLOR]')
	xbmc.executebuiltin("Container.Refresh")

#######################################################################
#					REMOVE ADVANCEDSETTINGS.XML FILE
#######################################################################

def REMOVE_ADVANCED_FILE():

	try:
		os.remove(ADVANCED_SET_FILE)
	except:
		dialog.ok(AddonTitle, "[B][COLOR white]Sorry, TDB Wizard encountered an error[/COLOR][/B]",'[COLOR white]We were unable to remove the keyboard.xml file.[/COLOR]')
		sys.exit(0)
		
	dialog.ok(AddonTitle, "[B][COLOR white]Success, we have removed the advancedsettings.xml file.[/COLOR][/B]",'[COLOR white]Thank you for using TDB Wizard[/COLOR]')
	xbmc.executebuiltin("Container.Refresh")

#######################################################################
#					PLAY VIDEO FUNCTION
#######################################################################

def PLAYVIDEO(url):
	xbmc.Player().play(url)

#######################################################################
#					OPEN THE SETTINGS DIALOG
#######################################################################

def OPEN_SETTINGS(params):
    plugintools.open_settings_dialog()

##############################    END    #########################################

##################################################################################
#						Which mode to select
#######################################################################

params=parameters.get_params()

url=None
name=None
mode=None
iconimage=None
fanart=None
description=None

try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:        
        mode=int(params["mode"])
except:
        pass
try:        
        fanart=urllib.unquote_plus(params["fanart"])
except:
        pass
try:        
        description=urllib.unquote_plus(params["description"])
except:
        pass

if mode==None or url==None or len(url)<1:
        INDEX()
		
elif mode==1:
		maintenance.clearCache()
        
elif mode==2:
		maintenance.deleteThumbnails()

elif mode==3:
		maintenance.purgePackages()

elif mode==4:
		ACCOUNT()
		
elif mode==5:
        MAINTENANCE_MENU()

elif mode==6:        
		wipe.FRESHSTART()
		
elif mode==7:
        COMINGSOON()

elif mode==8:
        BACKUPMENU()
		
elif mode==9:
        OPEN_SETTINGS(params)
		
elif mode==10:
        maintenance.deleteAddonDB()

elif mode==11:
        update.updateaddons()
		
elif mode==12:
        xbmc.executebuiltin("RunAddon(plugin.video.tdbwizard)")
		
elif mode==13:
        maintenance.Fix_Special(url)

elif mode==14:
        versioncheck.XBMC_Version()
		
elif mode==15:
        speedtest.runtest(url)
		
elif mode==16:
        SPEEDTEST()

elif mode==17:
       ADD_COMMUNITY_BUILD()

elif mode==18:
       community.CommunityUpdateNotice()

elif mode==22:
        GET_SUPPORT()

elif mode==25:
		maintenance.DeleteCrashLogs()
		
elif mode==26:
		maintenance.HidePasswords()

elif mode==27:
		maintenance.lib()

elif mode==28:
		LATEST_LIST()
	
elif mode==29:
		DOWNLOADLIB()
		
elif mode==30:
		ADVANCEDSETTINGS()
		
elif mode==31:
		maintenance.autocleanask()
		
elif mode==32:
		LATESTAPKSWITHLIB()
		
elif mode==33:
        update.check()

elif mode==35:
        maintenance.viewLogFile()
		
elif mode==36:
        uploadlog.LogUploader()

elif mode==37:
		maintenance.UnhidePasswords()

elif mode==38:
		tdb.CUSTOM_BUILD()
		
elif mode==40:
		LATEST_WINDOWS()
		
elif mode==41:
		LATEST_ANDROID()
		
elif mode==42:
		LATEST_IOS()
		
elif mode==43:
		LATEST_OSX()

elif mode==44:
        versioncheck.BUILD_Version()

elif mode==46:
        KODI_TOOLS()

elif mode==47:
        SPORT_LISTINGS()

elif mode==48:
		vulcan.CUSTOM_BUILD()
		
elif mode==49:
		dialog.ok(AddonTitle, url )
		xbmc.executebuiltin("Container.Refresh")

elif mode==50:
        tdb.BUILDMENU()

elif mode==51:
        leetv.BUILDMENU()

elif mode==52:
        doneright.BUILDMENU()

elif mode==53:
        kodiheaven.BUILDMENU()
		
elif mode==54:
        mystic.BUILDMENU()
		
elif mode==55:
        kiddo.BUILDMENU()

elif mode==56:
        vulcan.BUILDMENU()

elif mode==57:
        demonstratorz.BUILDMENU()

elif mode==58:
	Common.WriteReview(url)

elif mode==59:
	Common.ListReview(url)

elif mode==60:
        youtube.MAINMENU()
		
elif mode==61:
        youtube.LOADLIST(name,url)
		
elif mode==62:
        youtube.LOADITEM(name,url)
		
elif mode==63:
        youtube.OTHER_CHANNELS(url)
		
elif mode==64:
        search.YOUTUBE()
		
elif mode==65:
        search.COMMUNITY()
		
elif mode==66:
        search.BUILDS()
		
elif mode==67:
        search.ALL()
		
elif mode==68:
        youtube.TEAMTDB()

elif mode==69:
        backuprestore.FullBackup()

elif mode==70:
        backuprestore.Backup()
		
elif mode==71:
        backuprestore.Restore()
	
elif mode==72:
        backuprestore.ListBackDel()
		
elif mode==73:
        backuprestore.DeleteAllBackups()
		
elif mode==74:
        extras.EXTRAS_MENU()
		
elif mode==75:
        extras.HORUS_INTRO()
		
elif mode==76:
        extras.ENABLE_HORUS_INTRO()

elif mode==77:
        extras.SPMC_MINIMIZE()

elif mode==79:
        GET_SUPPORT()
		
elif mode==80:
        VIEW_CHANGELOG()
		
elif mode==81:
        VIEW_CREDITS()

elif mode==82:
        maintenance.viewLogFile()

elif mode==83:
        Common.BUILDER(name,url,iconimage,fanart,description)

elif mode==84:
        KODI_CONTACTS()

elif mode==85:
        print "############   ATTEMPT TO KILL XBMC/KODI   #################"
        Common.killxbmc()

elif mode==86:
        print "############   ATTEMPT TO KILL XBMC/KODI   #################"
        Common.KillKodi()

elif mode==87:
       community.COMMUNITY()

elif mode==88:
        BUILDMENU()
	
elif mode==89:
        installer.INSTALLEXE(name,url,description)

elif mode==90:
        installer.INSTALL(name,url,description)
		
elif mode==91:
        installer.INSTALLAPK(name,url,description)

elif mode==92:
        status.Check()
		
elif mode==93:
       community.SHOWCOMMUNITYBUILDS(name, url, description)
	 
elif mode==94:
        installer.INSTALLLIB(name,url,description)

elif mode==95:
        PLAYVIDEO(url)
		
elif mode==96:
        installer.INSTALL_COMMUNITY(name,url,description)
	 
elif mode==97:
        Common.BUILDER_COMMUNITY(name,url,iconimage,fanart,description)

elif mode==98:
        installer.INSTALL_ADVANCED(name,url,description)

elif mode==99:
		installer.INSTALL(name,url,description)

elif mode==100:
		backuprestore.READ_ZIP(url)
	
elif mode==101:
		backuprestore.DeleteBackup(url)

elif mode==102:
        xbmc.executebuiltin(description)
        sys.exit(0)

elif mode==103:
		backuprestore.BACKUP_RD_TRAKT()

elif mode==104:
		backuprestore.RESTORE_RD_TRAKT()

elif mode==105:
		backuprestore.READ_ZIP_TRAKT(url)

elif mode==106:
		LATEST_NEWS()

elif mode==107:
		backuprestore.TV_GUIDE_BACKUP()
		
elif mode==108:
		backuprestore.ADDON_DATA_BACKUP()
		
elif mode==109:
		maintenance.RUYA_FIX()

elif mode==110:
		extras.PLAYERCORE_ANDROID()

elif mode==111:
		dialog.ok(AddonTitle, '[COLOR lightskyblue][B]Current Time: [/B][/COLOR][COLOR white]' + THE_TIME + '[/COLOR]', '[COLOR lightskyblue][B]Current Date: [/B][/COLOR][COLOR white]' + THE_DATE + '[/COLOR]')

elif mode==112:
		maintenance.AUTO_CLEAN_ON_OFF()

elif mode==113:
		maintenance.AUTO_WEEKLY_CLEAN_ON_OFF()

elif mode==114:
		xbmc.executebuiltin("Container.Refresh")

elif mode==115:
		extras.PLAYERCORE_WINDOWS()

elif mode==116:
		Common.SHOW_PICTURE(fanart)

elif mode==117:
		maintenance.BASE64_ENCODE_DECODE()

elif mode==118:
		Common.WriteTicket()

elif mode==119:
		Common.ListTickets()

elif mode==120:
		dialog.ok(AddonTitle, url )
		xbmc.executebuiltin("Container.Refresh")

elif mode==121:
		get_addons.MENU()

elif mode==122:
		get_addons.GET_SINGLE(name,url)
		
elif mode==123:
		get_addons.GET_MULTI(name,url)

elif mode==124:
		xbmc.executebuiltin("ReloadSkin()")

elif mode==125:
		xbmc.executebuiltin("ActivateWindow(busydialog)")
		xbmc.executebuiltin("UpdateAddonRepos")
		xbmc.executebuiltin("UpdateLocalAddons")
		xbmc.executebuiltin("Dialog.Close(busydialog)")
		
elif mode==126:
		maintenance.OPEN_EXTERNAL_SETTINGS()

elif mode==127:
		xbmc.executebuiltin("ToggleDebug")

elif mode==128:
		REMOVE_KEYBOARD_FILE()

elif mode==129:
		KEYMAPS()

elif mode==130:
        installer.INSTALL_KEYMAP(name,url,description)

elif mode==131:
		REMOVE_ADVANCED_FILE()

elif mode==132:
		extras.YOUTUBE_REMOVE()
		
elif mode==140:
		community.NEXT_PAGE_COMMUNITY(description)
		
elif mode==141:
		community.PROTECTED_FOLDER()
		
elif mode==142:
		community.NEXT_PAGE_PROTECTED(description)
		
elif mode==143:
		community.SHOWPROTECTEDBUILDS(name,url,description)

elif mode==144:
		FANRIFFIC_THEMES()

elif mode==145:
        installer.INSTALL_FANRIFFIC(name,url,description)

elif mode==146:
		extras.SPORTS_DEVIL_FIX()
		
elif mode==147:
		maintenance.CHECK_BROKEN_REPOS()

elif mode==148:
		maintenance.CHECK_BROKEN_SOURCES()

xbmcplugin.endOfDirectory(int(sys.argv[1]))