import xbmc, xbmcaddon, xbmcgui, xbmcplugin,os,base64,sys,xbmcvfs
import shutil
import urllib2,urllib
import re
import glob
import common as Common
import downloader
import extract
import time
import os
import installer
import plugintools

AddonTitle="[COLOR ghostwhite]TDB[/COLOR] [COLOR lightskyblue]Wizard[/COLOR]"
thumbnailPath = xbmc.translatePath('special://userdata/Thumbnails');
cachePath = os.path.join(xbmc.translatePath('special://home'), 'cache')
tempPath = xbmc.translatePath('special://temp')
addonPath = os.path.join(os.path.join(xbmc.translatePath('special://home'), 'addons'),'plugin.video.tdbwizard')
mediaPath = os.path.join(addonPath, 'resources/art')
databasePath = xbmc.translatePath('special://userdata/Database')
USERDATA = xbmc.translatePath('special://userdata/')
AddonData = xbmc.translatePath('special://userdata/addon_data')
MaintTitle="[COLOR ghostwhite]TDB[/COLOR] [COLOR lightskyblue]Maintenance Tools[/COLOR]"
EXCLUDES     = ['plugin.video.tdbwizard','repository.tdbegley.official','script.module.requests','temp','kodi.log','kodi.log.old','spmc.log','spmc.log.old','dbmc.log','dbmc.log.old']
dp = xbmcgui.DialogProgress()
Windows = xbmc.translatePath('special://home')
WindowsCache = xbmc.translatePath('special://home')
OtherCache = xbmc.translatePath('special://home/temp')
dialog = xbmcgui.Dialog()
BASEURL = base64.b64decode(b'aHR0cDovL3RlYW10ZGJidWlsZHMuY28udWsv')

#######################################################################
#						Cache Functions
#######################################################################

class Gui(xbmcgui.WindowXMLDialog):
    def __init__(self, *args, **kwargs):
        xbmcgui.WindowXMLDialog.__init__(self)
        self.header = kwargs.get("header")
        self.content = kwargs.get("content")

    def onInit(self):
        self.getControl(1).setLabel(self.header)
        self.getControl(5).setText(self.content)

path   = xbmcaddon.Addon().getAddonInfo('path').decode("utf-8")

class cacheEntry:
    def __init__(self, namei, pathi):
        self.name = namei
        self.path = pathi	

#######################################################################
#						Maintenance Functions
#######################################################################
def setupCacheEntries():
    entries = 5 #make sure this refelcts the amount of entries you have
    dialogName = ["WTF", "4oD", "BBC iPlayer", "Simple Downloader", "ITV"]
    pathName = ["special://profile/addon_data/plugin.video.whatthefurk/cache", "special://profile/addon_data/plugin.video.4od/cache",
					"special://profile/addon_data/plugin.video.iplayer/iplayer_http_cache","special://profile/addon_data/script.module.simple.downloader",
                    "special://profile/addon_data/plugin.video.itv/Images"]
                    
    cacheEntries = []
    
    for x in range(entries):
        cacheEntries.append(cacheEntry(dialogName[x],pathName[x]))
    
    return cacheEntries

#######################################################################
#						Clear Cache
#######################################################################

def clearCache():
    
    if os.path.exists(cachePath)==True:    
        for root, dirs, files in os.walk(cachePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete Kodi Cache Files", str(file_count) + " files found", "Do you want to delete them?"):
                
                    for f in files:
                        try:
							if (f.endswith(".log")): continue
							os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
    if os.path.exists(tempPath)==True:    
        for root, dirs, files in os.walk(tempPath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete Kodi Temp Files", str(file_count) + " files found", "Do you want to delete them?"):
                    for f in files:
                        try:
                            if (f.endswith(".log")): continue
                            os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
    if xbmc.getCondVisibility('system.platform.ATV2'):
        atv2_cache_a = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'Other')
        
        for root, dirs, files in os.walk(atv2_cache_a):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete ATV2 Cache Files", str(file_count) + " files found in 'Other'", "Do you want to delete them?"):
                
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass
        atv2_cache_b = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'LocalAndRental')
        
        for root, dirs, files in os.walk(atv2_cache_b):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:

                dialog = xbmcgui.Dialog()
                if dialog.yesno("Delete ATV2 Cache Files", str(file_count) + " files found in 'LocalAndRental'", "Do you want to delete them?"):
                
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass    
                
    cacheEntries = setupCacheEntries()
                                         
    for entry in cacheEntries:
        clear_cache_path = xbmc.translatePath(entry.path)
        if os.path.exists(clear_cache_path)==True:    
            for root, dirs, files in os.walk(clear_cache_path):
                file_count = 0
                file_count += len(files)
                if file_count > 0:

                    dialog = xbmcgui.Dialog()
                    if dialog.yesno(MaintTitle,str(file_count) + "%s cache files found"%(entry.name), "Do you want to delete them?"):
                        for f in files:
                            os.unlink(os.path.join(root, f))
                        for d in dirs:
                            shutil.rmtree(os.path.join(root, d))
                            
                else:
                    pass
                

    dialog = xbmcgui.Dialog()
    dialog.ok(MaintTitle, "Done Clearing Cache files")

#######################################################################
#						Delete Thumbnails
#######################################################################
    
def deleteAddonDB():

	dialog = xbmcgui.Dialog()
	xbmc_version=xbmc.getInfoLabel("System.BuildVersion")
	version=float(xbmc_version[:4])

	if version >= 17.0 and version <= 17.9:
		codename = 'Krypton'
	else:
		codename = 'Pass'
	
	if codename == "Pass":
		try:
			for root, dirs, files in os.walk(databasePath,topdown=True):
				dirs[:] = [d for d in dirs]
				for name in files:
					if "addons" in name.lower():
						try:
							os.remove(os.path.join(root,name))
							dialog.ok(MaintTitle,str(name)+  "removed!",'','[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')
						except: 
							dialog.ok(MaintTitle,'Error Removing ' + str(name),'','[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')
							pass
					else:
						continue
		except:
			pass
	else:
		dialog.ok(MaintTitle,'This feature is not available in Kodi 17 Krypton','','[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')

#######################################################################
#						Delete Thumbnails
#######################################################################
    
def deleteThumbnails():
    
    if os.path.exists(thumbnailPath)==True:  
            dialog = xbmcgui.Dialog()
            if dialog.yesno("Delete Thumbnails", "This option deletes all thumbnails", "Are you sure you want to do this?"):
                for root, dirs, files in os.walk(thumbnailPath):
                    file_count = 0
                    file_count += len(files)
                    if file_count > 0:                
                        for f in files:
                            try:
                                os.unlink(os.path.join(root, f))
                            except:
								pass
    else:
        pass
    
    text13 = os.path.join(databasePath,"Textures13.db")
    try:
		os.unlink(text13)
    except OSError:
        pass

	dialog.ok(MaintTitle, 'Thimbnails have been deleted.','Thank you for using TDB Wizard')

def CHECK_BROKEN_SOURCES():

	found = 0
	SOURCES_FILE =  xbmc.translatePath('special://home/userdata/sources.xml')
	dialog = xbmcgui.Dialog()
	a=open(SOURCES_FILE).read()	
	b=a.replace('\n','U').replace('\r','F')
	match=re.compile('<source>(.+?)</source>').findall(str(b))
	xbmc.executebuiltin( "ActivateWindow(busydialog)" )
	counter = 0
	for item in match:
		name=re.compile('<name>(.+?)</name>').findall(item)[0]
		checker=re.compile('<path pathversion="1">(.+?)</path>').findall(item)[0]
		if "http" in str(checker):
			try:
				Common.OPEN_URL(checker)
			except:
				choice = xbmcgui.Dialog().yesno("[COLOR red][B]Error conencting to the following: [/B][/COLOR]", "[COLOR white]Source Name: " + name + "[/COLOR]", "[COLOR white]Source URL: " + checker + "[/COLOR]","[COLOR dodgerblue][B]Would you like to remove this source now?[/B][/COLOR]",yeslabel='[B][COLOR lime]YES[/COLOR][/B]',nolabel='[B][COLOR lightskyblue]NO[/COLOR][/B]')
				counter = counter + 1
				if choice == 1:
					found = 1
					h=open(SOURCES_FILE).read()
					i=h.replace('\n','U').replace('\r','F')
					j=i.replace(str(item), '')
					k=j.replace('U','\n').replace('F','\r')
					l=k.replace('<source></source>','').replace('        \n','')
					f= open(SOURCES_FILE, mode='w')
					f.write(l)
					f.close()

	xbmc.executebuiltin( "Dialog.Close(busydialog)" )

	if found == 0:
		dialog.ok(AddonTitle,'[COLOR white]We have now finished checked all of your sources.[/COLOR]', '[COLOR dodgerblue][B]WE FOUND NO PROBLEMS IN YOUR SOURCE FILE![/B][/COLOR]','[COLOR white]Thank you for using TDB Wizard[/COLOR]')
	else:
		if counter == 1:
			dialog.ok(AddonTitle,'[COLOR white]We have now finished checked all of your sources.[/COLOR]', '[COLOR dodgerblue][B]WE FOUND ' + str(counter) + ' PROBLEM IN YOUR SOURCE FILE![/B][/COLOR]','[COLOR white]Thank you for using TDB Wizard[/COLOR]')
		else:
			dialog.ok(AddonTitle,'[COLOR white]We have now finished checked all of your sources.[/COLOR]', '[COLOR dodgerblue][B]WE FOUND ' + str(counter) + ' PROBLEMS IN YOUR SOURCE FILE![/B][/COLOR]','[COLOR white]Thank you for using TDB Wizard[/COLOR]')

def CHECK_BROKEN_REPOS():

	HOME =  xbmc.translatePath('special://home/addons/')
	dialog = xbmcgui.Dialog()
	dp.create(AddonTitle,"Checking Repositories...",'', 'Please Wait')
	url = HOME
	for root, dirs, files in os.walk(url):
		for file in files:
			if file == "addon.xml":
				dp.update(0,"Checking","[COLOR smokewhite]" + file + "[/COLOR]", "Please wait.....")
				a=open((os.path.join(root, file))).read()	
				if "info compressed=" in str(a):
					match = re.compile('<info compressed="false">(.+?)</info>').findall(a)
					for checker in match:
						try:
							Common.OPEN_URL(checker)
						except:
							match = re.compile('<addon id="(.+?)".+?ame="(.+?)" version').findall(a)
							for repo_id,repo_name in match:
								dialog = xbmcgui.Dialog()
								default_path = xbmc.translatePath("special://home/addons/")
								file_path = xbmc.translatePath(file)
								full_path = default_path + repo_id
								choice = xbmcgui.Dialog().yesno(AddonTitle,"[COLOR white]The [/COLOR][COLOR dodgerblue]" + repo_name + "[/COLOR] [COLOR white] appears to be broken. We attempted to connect to the repo but it was unsuccessful.[/COLOR]",'[COLOR red]To remove this repository please click YES[/COLOR]',yeslabel='[B][COLOR lime]YES[/COLOR][/B]',nolabel='[B][COLOR lightskyblue]NO[/COLOR][/B]')
								if choice == 1:
									try:
										shutil.rmtree(full_path)
										dialog.ok(AddonTitle,"[COLOR white]The " + repo_name + " was successfully removed from your system.[/COLOR]")
									except:
										dialog.ok(AddonTitle,"[COLOR white]Sorry we were unable to remove " + repo_name + "[/COLOR]")

	dialog.ok(AddonTitle,"[COLOR white]We have now finished checked all of your repositories. Thank you for using TDB Wizard[/COLOR]")

#######################################################################
#						Delete Packages
#######################################################################

def purgePackages():
    
    purgePath = xbmc.translatePath('special://home/addons/packages')
    dialog = xbmcgui.Dialog()
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
    if dialog.yesno("Delete Package Cache Files", "%d packages found."%file_count, "Delete Them?"):  
        for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:            
                for f in files:
                    os.unlink(os.path.join(root, f))
                for d in dirs:
                    shutil.rmtree(os.path.join(root, d))
                dialog = xbmcgui.Dialog()
                dialog.ok(MaintTitle, "Deleting Packages all done")
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok(MaintTitle, "No Packages to Purge")

#######################################################################
#						Convert physical to special
#######################################################################	

def Fix_Special(url):

    HOME =  xbmc.translatePath('special://home/userdata/')
    dialog = xbmcgui.Dialog()
    dp.create(AddonTitle,"Renaming paths...",'', 'Please Wait')
    url = HOME
    for root, dirs, files in os.walk(url):
        for file in files:
            if file.endswith(".xml"):
                 dp.update(0,"Fixing","[COLOR smokewhite]" + file + "[/COLOR]", "Please wait.....")
                 a=open((os.path.join(root, file))).read()
                 b=a.replace(HOME, 'special://home/userdata/')
                 f= open((os.path.join(root, file)), mode='w')
                 f.write(str(b))
                 f.close()
				 
    dialog.ok(MaintTitle, "All physical paths have been converted to special","To complete this process you must force close Kodi now!")
    Common.KillKodi()
	
#######################################################################
#						Autoclean Function
#######################################################################
def setupCacheEntries():
    entries = 5 #make sure this refelcts the amount of entries you have
    dialogName = ["WTF", "4oD", "BBC iPlayer", "Simple Downloader", "ITV"]
    pathName = ["special://profile/addon_data/plugin.video.whatthefurk/cache", "special://profile/addon_data/plugin.video.4od/cache",
					"special://profile/addon_data/plugin.video.iplayer/iplayer_http_cache","special://profile/addon_data/script.module.simple.downloader",
                    "special://profile/addon_data/plugin.video.itv/Images"]
                    
    cacheEntries = []
    
    for x in range(entries):
        cacheEntries.append(cacheEntry(dialogName[x],pathName[x]))
    
    return cacheEntries

#######################################################################
#						Delete Crash Log Function
#######################################################################

def DeleteCrashLogs():  

	HomeDir = xbmc.translatePath('special://home')
	WindowsCache = os.path.join(xbmc.translatePath('special://home'), 'cache')
	OtherCache = xbmc.translatePath('special://temp')
	
	if os.path.exists(HomeDir)==True:   
		dialog = xbmcgui.Dialog()
		if dialog.yesno(MaintTitle, '', "Do you want to delete old crash logs?"):
			path=Windows
			import glob
			for infile in glob.glob(os.path.join(path, '*.dmp')):
				File=infile
				print infile
				os.remove(infile)
				
			for infile in glob.glob(os.path.join(path, '*.txt')):
				File=infile
				print infile
				os.remove(infile)
				
		if os.path.exists(WindowsCache)==True:   
			path=WindowsCache
			import glob
			for infile in glob.glob(os.path.join(path, '*.dmp')):
				File=infile
				print infile
				os.remove(infile)
				
			for infile in glob.glob(os.path.join(path, '*.txt')):
				File=infile
				print infile
				os.remove(infile)

		if os.path.exists(OtherCache)==True:   
			path=OtherCache
			import glob
			for infile in glob.glob(os.path.join(path, '*.dmp')):
				File=infile
				print infile
				os.remove(infile)
				
			for infile in glob.glob(os.path.join(path, '*.txt')):
				File=infile
				print infile
				os.remove(infile)
		
		dialog = xbmcgui.Dialog()
		dialog.ok(MaintTitle, "Crash logs deleted", "[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]")
	else:
		dialog = xbmcgui.Dialog()
		dialog.ok(MaintTitle, "An error occured", "[COLOR smokewhite]Please report this to TDB Wizard[/COLOR]")

def HidePasswords():

    dialog = xbmcgui.Dialog()
    HOME         =  xbmc.translatePath('special://home')
    if dialog.yesno(MaintTitle, "Are You Sure You Want To Hide Passwords?", ""):
        dialog = xbmcgui.Dialog()
        dp.create(MaintTitle,"Renaming paths...",'', 'Please Wait')
        for root, dirs, files in os.walk(HOME):
            for f in files:
                if f == "settings.xml":
                    FILE=open(os.path.join(root, f)).read()
                    match=re.compile('<setting id=(.+?)>').findall (FILE)
                    for LINE in match:
                        if 'pass' in LINE:
                            if not 'option="hidden"' in LINE:
                                try:
                                    CHANGEME=LINE.replace('/',' option="hidden"/') 
                                    f = open(os.path.join(root, f), mode='w')
                                    f.write(str(FILE).replace(LINE,CHANGEME))
                                    f.close()
                                except:pass
			
        dialog.ok(MaintTitle, "All Passowrds are now hidden!", "[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]") 
		
                                            
def UnhidePasswords():

    dialog = xbmcgui.Dialog()
    HOME         =  xbmc.translatePath('special://home')
    if dialog.yesno(MaintTitle, "Are You Sure You Want To Make All Passwords Visable?", ""):
        dialog = xbmcgui.Dialog()
        dp.create(MaintTitle,"Renaming paths...",'', 'Please Wait')
        for root, dirs, files in os.walk(HOME):
            for f in files:
                if f == "settings.xml":
                    FILE=open(os.path.join(root, f)).read()
                    match=re.compile('<setting id=(.+?)>').findall (FILE)
                    for LINE in match:
                        if 'pass' in LINE:
                            if 'option="hidden"' in LINE:
                                try:
                                    CHANGEME=LINE.replace('option="hidden"','') 
                                    f = open(os.path.join(root, f), mode='w')
                                    f.write(str(FILE).replace(LINE,CHANGEME))
                                    f.close()
                                except:pass
			
        dialog.ok(MaintTitle, "All Passowrds are now visable!", "[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]") 

def viewLogFile():
	kodilog = xbmc.translatePath('special://logpath/kodi.log')
	spmclog = xbmc.translatePath('special://logpath/spmc.log')
	dbmclog = xbmc.translatePath('special://logpath/dbmc.log')
	kodiold = xbmc.translatePath('special://logpath/kodi.old.log')
	spmcold = xbmc.translatePath('special://logpath/spmc.old.log')
	dbmcold = xbmc.translatePath('special://logpath/dbmc.old.log')

	if os.path.exists(dbmclog):
		if os.path.exists(dbmclog) and os.path.exists(dbmcold):
			choice = xbmcgui.Dialog().yesno(MaintTitle,"Current & Old Log Detected on your system.","Which log would you like to view?","", yeslabel='[B]OLD[/B]',nolabel='[B]CURRENT[/B]')
			if choice == 0:
				f = open(dbmclog,mode='r'); msg = f.read(); f.close()
				Common.TextBoxes("%s - dbmc.log" % "[COLOR white]" + msg + "[/COLOR]")
			else:
				f = open(dbmcold,mode='r'); msg = f.read(); f.close()
				Common.TextBoxes("%s - dbmc.old.log" % "[COLOR white]" + msg + "[/COLOR]")
		else:
			f = open(dbmclog,mode='r'); msg = f.read(); f.close()
			Common.TextBoxes("%s - dbmc.log" % "[COLOR white]" + msg + "[/COLOR]")

	if os.path.exists(spmclog):
		if os.path.exists(spmclog) and os.path.exists(spmcold):
			choice = xbmcgui.Dialog().yesno(MaintTitle,"Current & Old Log Detected on your system.","Which log would you like to view?","", yeslabel='[B]OLD[/B]',nolabel='[B]CURRENT[/B]')
			if choice == 0:
				f = open(spmclog,mode='r'); msg = f.read(); f.close()
				Common.TextBoxes("%s - spmc.log" % "[COLOR white]" + msg + "[/COLOR]")
			else:
				f = open(spmcold,mode='r'); msg = f.read(); f.close()
				Common.TextBoxes("%s - spmc.old.log" % "[COLOR white]" + msg + "[/COLOR]")
		else:
			f = open(spmclog,mode='r'); msg = f.read(); f.close()
			Common.TextBoxes("%s - spmc.log" % "[COLOR white]" + msg + "[/COLOR]")
			
	if os.path.exists(kodilog):
		if os.path.exists(kodilog) and os.path.exists(kodiold):
			choice = xbmcgui.Dialog().yesno(MaintTitle,"Current & Old Log Detected on your system.","Which log would you like to view?","", yeslabel='[B]OLD[/B]',nolabel='[B]CURRENT[/B]')
			if choice == 0:
				f = open(kodilog,mode='r'); msg = f.read(); f.close()
				Common.TextBoxes("%s - kodi.log" % "[COLOR white]" + msg + "[/COLOR]")
			else:
				f = open(kodiold,mode='r'); msg = f.read(); f.close()
				Common.TextBoxes("%s - kodi.old.log" % "[COLOR white]" + msg + "[/COLOR]")
		else:
			f = open(kodilog,mode='r'); msg = f.read(); f.close()
			Common.TextBoxes("%s - kodi.log" % "[COLOR white]" + msg + "[/COLOR]")

	if os.path.isfile(kodilog) or os.path.isfile(spmclog) or os.path.isfile(dbmclog):
		return True
	else:
		dialog.ok(MaintTitle,'Sorry, No log file was found.','','[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')

def autocleanask():
    
	choice = xbmcgui.Dialog().yesno(MaintTitle, 'Selecting [COLOR green]YES[/COLOR] will delete your cache, thumbnails and packages.','[I][COLOR lightsteelblue]Do you wish to continue?[/I][/COLOR]', yeslabel='[B][COLOR green]YES[/COLOR][/B]',nolabel='[B][COLOR lightskyblue]NO[/COLOR][/B]')
	if choice == 1:
		autocleannow()
	
def autocleannow():

    HomeDir = xbmc.translatePath('special://home')
    WindowsCache = os.path.join(xbmc.translatePath('special://home'), 'cache')
    OtherCache = xbmc.translatePath('special://temp')
	
    if os.path.exists(HomeDir)==True:   
        path=Windows
        import glob
        for infile in glob.glob(os.path.join(path, '*.dmp')):
            File=infile
            print infile
            os.remove(infile)
			
        for infile in glob.glob(os.path.join(path, '*.txt')):
            File=infile
            print infile
            os.remove(infile)
				
        if os.path.exists(WindowsCache)==True:   
            path=WindowsCache
            import glob
            for infile in glob.glob(os.path.join(path, '*.dmp')):
                File=infile
                print infile
                os.remove(infile)
				
            for infile in glob.glob(os.path.join(path, '*.txt')):
                File=infile
                print infile
                os.remove(infile)

        if os.path.exists(OtherCache)==True:   
            path=OtherCache
            import glob
            for infile in glob.glob(os.path.join(path, '*.dmp')):
                File=infile
                print infile
                os.remove(infile)
				
            for infile in glob.glob(os.path.join(path, '*.txt')):
                File=infile
                print infile
                os.remove(infile)

    if os.path.exists(cachePath)==True:    
        for root, dirs, files in os.walk(cachePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                    for f in files:
                        try:
							if (f.endswith(".log")): continue
							os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
				
    if os.path.exists(tempPath)==True:    
        for root, dirs, files in os.walk(tempPath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                    for f in files:
                        try:
                            if (f.endswith(".log")): continue
                            os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
    if xbmc.getCondVisibility('system.platform.ATV2'):
        atv2_cache_a = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'Other')
        
        for root, dirs, files in os.walk(atv2_cache_a):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:                
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass
        atv2_cache_b = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'LocalAndRental')
        
        for root, dirs, files in os.walk(atv2_cache_b):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass    
                
    cacheEntries = setupCacheEntries()
                                         
    for entry in cacheEntries:
        clear_cache_path = xbmc.translatePath(entry.path)
        if os.path.exists(clear_cache_path)==True:    
            for root, dirs, files in os.walk(clear_cache_path):
                file_count = 0
                file_count += len(files)
                if file_count > 0:
                        for f in files:
                            os.unlink(os.path.join(root, f))
                        for d in dirs:
                            shutil.rmtree(os.path.join(root, d))
                            
                else:
                    pass
        
    if os.path.exists(thumbnailPath)==True:  
                for root, dirs, files in os.walk(thumbnailPath):
                    file_count = 0
                    file_count += len(files)
                    if file_count > 0:                
                        for f in files:
                            try:
                                os.unlink(os.path.join(root, f))
                            except:
								pass
    else:
        pass
    
    text13 = os.path.join(databasePath,"Textures13.db")
    try:
		os.unlink(text13)
    except OSError:
        pass
		
    purgePath = xbmc.translatePath('special://home/addons/packages')
    dialog = xbmcgui.Dialog()
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:            
                for f in files:
                    os.unlink(os.path.join(root, f))
                for d in dirs:
                    shutil.rmtree(os.path.join(root, d))

    xbmcgui.Dialog().ok(MaintTitle,"Auto clean finished.","Your cache, thumbnails and packages have all been deleted")

def AUTO_CLEAR_CACHE_MB():

    HomeDir = xbmc.translatePath('special://home')
    WindowsCache = os.path.join(xbmc.translatePath('special://home'), 'cache')
    OtherCache = xbmc.translatePath('special://temp')

    if os.path.exists(cachePath)==True:    
        for root, dirs, files in os.walk(cachePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                    for f in files:
                        try:
							if (f.endswith(".log")): continue
							os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
				
    if os.path.exists(tempPath)==True:    
        for root, dirs, files in os.walk(tempPath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                    for f in files:
                        try:
                            if (f.endswith(".log")): continue
                            os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
    if xbmc.getCondVisibility('system.platform.ATV2'):
        atv2_cache_a = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'Other')
        
        for root, dirs, files in os.walk(atv2_cache_a):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:                
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass
        atv2_cache_b = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'LocalAndRental')
        
        for root, dirs, files in os.walk(atv2_cache_b):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass    
                
    cacheEntries = setupCacheEntries()
                                         
    for entry in cacheEntries:
        clear_cache_path = xbmc.translatePath(entry.path)
        if os.path.exists(clear_cache_path)==True:    
            for root, dirs, files in os.walk(clear_cache_path):
                file_count = 0
                file_count += len(files)
                if file_count > 0:
                        for f in files:
                            os.unlink(os.path.join(root, f))
                        for d in dirs:
                            shutil.rmtree(os.path.join(root, d))
                            
                else:
                    pass

def AUTO_CLEAR_PACKAGES_MB():

    time.sleep(60)

    purgePath = xbmc.translatePath('special://home/addons/packages')
    dialog = xbmcgui.Dialog()
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:            
                for f in files:
                    os.unlink(os.path.join(root, f))
                for d in dirs:
                    shutil.rmtree(os.path.join(root, d))

def AUTO_CLEAR_THUMBS_MB():

    if os.path.exists(thumbnailPath)==True:  
                for root, dirs, files in os.walk(thumbnailPath):
                    file_count = 0
                    file_count += len(files)
                    if file_count > 0:                
                        for f in files:
                            try:
                                os.unlink(os.path.join(root, f))
                            except:
								pass
    else:
        pass
    
    text13 = os.path.join(databasePath,"Textures13.db")
    try:
		os.unlink(text13)
    except OSError:
        pass

def Auto_Startup():
    HomeDir = xbmc.translatePath('special://home')
    WindowsCache = os.path.join(xbmc.translatePath('special://home'), 'cache')
    OtherCache = xbmc.translatePath('special://temp')
	
    if os.path.exists(HomeDir)==True:   
        path=Windows
        import glob
        for infile in glob.glob(os.path.join(path, '*.dmp')):
            File=infile
            print infile
            os.remove(infile)
			
        for infile in glob.glob(os.path.join(path, '*.txt')):
            File=infile
            print infile
            os.remove(infile)
				
        if os.path.exists(WindowsCache)==True:   
            path=WindowsCache
            import glob
            for infile in glob.glob(os.path.join(path, '*.dmp')):
                File=infile
                print infile
                os.remove(infile)
				
            for infile in glob.glob(os.path.join(path, '*.txt')):
                File=infile
                print infile
                os.remove(infile)

        if os.path.exists(OtherCache)==True:   
            path=OtherCache
            import glob
            for infile in glob.glob(os.path.join(path, '*.dmp')):
                File=infile
                print infile
                os.remove(infile)
				
            for infile in glob.glob(os.path.join(path, '*.txt')):
                File=infile
                print infile
                os.remove(infile)

    if os.path.exists(cachePath)==True:    
        for root, dirs, files in os.walk(cachePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                    for f in files:
                        try:
							if (f.endswith(".log")): continue
							os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
				
    if os.path.exists(tempPath)==True:    
        for root, dirs, files in os.walk(tempPath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                    for f in files:
                        try:
                            if (f.endswith(".log")): continue
                            os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
    if xbmc.getCondVisibility('system.platform.ATV2'):
        atv2_cache_a = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'Other')
        
        for root, dirs, files in os.walk(atv2_cache_a):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:                
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass
        atv2_cache_b = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'LocalAndRental')
        
        for root, dirs, files in os.walk(atv2_cache_b):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass    
                
    cacheEntries = setupCacheEntries()
                                         
    for entry in cacheEntries:
        clear_cache_path = xbmc.translatePath(entry.path)
        if os.path.exists(clear_cache_path)==True:    
            for root, dirs, files in os.walk(clear_cache_path):
                file_count = 0
                file_count += len(files)
                if file_count > 0:
                        for f in files:
                            os.unlink(os.path.join(root, f))
                        for d in dirs:
                            shutil.rmtree(os.path.join(root, d))
                            
                else:
                    pass
    
    text13 = os.path.join(databasePath,"Textures13.db")
    try:
		os.unlink(text13)
    except OSError:
        pass
		
    purgePath = xbmc.translatePath('special://home/addons/packages')
    dialog = xbmcgui.Dialog()
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:            
                for f in files:
                    os.unlink(os.path.join(root, f))
                for d in dirs:
                    shutil.rmtree(os.path.join(root, d))

def AutoCache():

    if os.path.exists(cachePath)==True:    
        for root, dirs, files in os.walk(cachePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                    for f in files:
                        try:
							if (f.endswith(".log")): continue
							os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
				
    if os.path.exists(tempPath)==True:    
        for root, dirs, files in os.walk(tempPath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:
                    for f in files:
                        try:
                            if (f.endswith(".log")): continue
                            os.unlink(os.path.join(root, f))
                        except:
                            pass
                    for d in dirs:
                        try:
                            shutil.rmtree(os.path.join(root, d))
                        except:
                            pass
                        
            else:
                pass
    if xbmc.getCondVisibility('system.platform.ATV2'):
        atv2_cache_a = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'Other')
        
        for root, dirs, files in os.walk(atv2_cache_a):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:                
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass
        atv2_cache_b = os.path.join('/private/var/mobile/Library/Caches/AppleTV/Video/', 'LocalAndRental')
        
        for root, dirs, files in os.walk(atv2_cache_b):
            file_count = 0
            file_count += len(files)
        
            if file_count > 0:
                    for f in files:
                        os.unlink(os.path.join(root, f))
                    for d in dirs:
                        shutil.rmtree(os.path.join(root, d))
                        
            else:
                pass    
                
    cacheEntries = setupCacheEntries()
                                         
    for entry in cacheEntries:
        clear_cache_path = xbmc.translatePath(entry.path)
        if os.path.exists(clear_cache_path)==True:    
            for root, dirs, files in os.walk(clear_cache_path):
                file_count = 0
                file_count += len(files)
                if file_count > 0:
                        for f in files:
                            os.unlink(os.path.join(root, f))
                        for d in dirs:
                            shutil.rmtree(os.path.join(root, d))
                            
                else:
                    pass

def AutoThumbs():

    if os.path.exists(thumbnailPath)==True:  
                for root, dirs, files in os.walk(thumbnailPath):
                    file_count = 0
                    file_count += len(files)
                    if file_count > 0:                
                        for f in files:
                            try:
                                os.unlink(os.path.join(root, f))
                            except:
								pass
    else:
        pass
    
    text13 = os.path.join(databasePath,"Textures13.db")
    try:
		os.unlink(text13)
    except OSError:
        pass

def AutoPackages():

    time.sleep(60)
    purgePath = xbmc.translatePath('special://home/addons/packages')
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
    for root, dirs, files in os.walk(purgePath):
            file_count = 0
            file_count += len(files)
            if file_count > 0:            
                for f in files:
                    os.unlink(os.path.join(root, f))
                for d in dirs:
                    shutil.rmtree(os.path.join(root, d))

def AutoCrash():  

	HomeDir = xbmc.translatePath('special://home')
	WindowsCache = os.path.join(xbmc.translatePath('special://home'), 'cache')
	OtherCache = xbmc.translatePath('special://temp')
	
	if os.path.exists(HomeDir)==True:   
		path=Windows
		import glob
		for infile in glob.glob(os.path.join(path, '*.dmp')):
			File=infile
			print infile
			os.remove(infile)
				
		for infile in glob.glob(os.path.join(path, '*.txt')):
			File=infile
			print infile
			os.remove(infile)
				
	if os.path.exists(WindowsCache)==True:   
		path=WindowsCache
		import glob
		for infile in glob.glob(os.path.join(path, '*.dmp')):
			File=infile
			print infile
			os.remove(infile)
				
		for infile in glob.glob(os.path.join(path, '*.txt')):
			File=infile
			print infile
			os.remove(infile)

	if os.path.exists(OtherCache)==True:   
		path=OtherCache
		import glob
		for infile in glob.glob(os.path.join(path, '*.dmp')):
			File=infile
			print infile
			os.remove(infile)
				
		for infile in glob.glob(os.path.join(path, '*.txt')):
			File=infile
			print infile
			os.remove(infile)
			
def OPEN_EXTERNAL_SETTINGS():

	SALTS  = os.path.join(os.path.join(xbmc.translatePath('special://home'), 'addons'),'plugin.video.salts')
	EXODUS = os.path.join(os.path.join(xbmc.translatePath('special://home'), 'addons'),'plugin.video.exodus')
	SPECTO = os.path.join(os.path.join(xbmc.translatePath('special://home'), 'addons'),'plugin.video.specto')
	
	if os.path.exists(SALTS):
		SALTS_SELECT = '[COLOR white][B]Open SALTS Settings[/B][/COLOR]'
	else:
		SALTS_SELECT = '[COLOR gray][B]SALTS (Not Installed)[/B][/COLOR]'

	if os.path.exists(EXODUS):
		EXODUS_SELECT = '[COLOR white][B]Open Exodus Settings[/B][/COLOR]'
	else:
		EXODUS_SELECT = '[COLOR gray][B]Exodus (Not Installed)[/B][/COLOR]'

	if os.path.exists(SPECTO):
		SPECTO_SELECT = '[COLOR white][B]Open Specto Settings[/B][/COLOR]'
	else:
		SPECTO_SELECT = '[COLOR gray][B]Specto (Not Installed)[/B][/COLOR]'

	choice = dialog.select(AddonTitle, [SALTS_SELECT,EXODUS_SELECT,SPECTO_SELECT])
	if choice == 0:
		if os.path.exists(SALTS):
			xbmc.executebuiltin("Addon.OpenSettings(plugin.video.salts)")
		else:
			dialog.ok(AddonTitle,"[COLOR white]Sorry, SALTS is not installed on this system so we cannot oepn the settings.[/COLOR]")
	if choice == 1:
		if os.path.exists(EXODUS):
			xbmc.executebuiltin("Addon.OpenSettings(plugin.video.exodus)")
		else:
			dialog.ok(AddonTitle,"[COLOR white]Sorry, Exodus is not installed on this system so we cannot oepn the settings.[/COLOR]")
	if choice == 2:
		if os.path.exists(SPECTO):
			xbmc.executebuiltin("Addon.OpenSettings(plugin.video.specto)")
		else:
			dialog.ok(AddonTitle,"[COLOR white]Sorry, Specto is not installed on this system so we cannot oepn the settings.[/COLOR]")


def RUYA_FIX():

	name = "[COLOR white][B]Ruya Fix[/B][/COLOR]"
	url = BASEURL + base64.b64decode(b'bWFpbnRlbmFuY2UvcnV5YV9maXguemlw')
	description = "NULL"
	#Check is the packages folder exists, if not create it.
	path = xbmc.translatePath(os.path.join('special://home/addons','packages'))
	if not os.path.exists(path):
		os.makedirs(path)
	buildname = name
	dp = xbmcgui.DialogProgress()
	dp.create(AddonTitle,"","","Build: " + buildname)
	buildname = "build"
	lib=os.path.join(path, buildname+'.zip')
	
	try:
		os.remove(lib)
	except:
		pass

	dialog = xbmcgui.Dialog()
	downloader.download(url, lib, dp)
	addonfolder = xbmc.translatePath(os.path.join('special://home','userdata'))
	time.sleep(2)
	dp.update(0,"","Extracting Zip Please Wait","")
	installer.unzip(lib,addonfolder,dp)
	time.sleep(1)
	try:
		os.remove(lib)
	except:
		pass

	HomeDir = xbmc.translatePath('special://home')
	WindowsCache = os.path.join(xbmc.translatePath('special://home'), 'cache')
	OtherCache = xbmc.translatePath('special://temp')

	if os.path.exists(WindowsCache)==True:   
		path=WindowsCache
		import glob
		for infile in glob.glob(os.path.join(path, '*.fi')):
			File=infile
			print infile
			os.remove(infile)

	if os.path.exists(OtherCache)==True:   
		path=OtherCache
		import glob
		for infile in glob.glob(os.path.join(path, '*.fi')):
			File=infile
			print infile
			os.remove(infile)

	dialog.ok(AddonTitle, "[COLOR white]RUYA Fix installed![/COLOR]",'',"[COLOR white]Thank you for using TDB Wizard![/COLOR]")

def BASE64_ENCODE_DECODE():

	dialog = xbmcgui.Dialog()
	choice = dialog.select(AddonTitle, ['Encode A String','Decode A String'])
	if choice == 0:
		vq = Common._get_keyboard( heading="Enter String to Encode" )
		if ( not vq ): return False, 0
		input = str(vq)
		output = base64.b64encode(input)
		dialog.ok(AddonTitle, '[COLOR lightskyblue]Orignal String: [/COLOR]' + input, '[COLOR lightskyblue]Encrypted String: [/COLOR]' + output)
	else:
		vq = Common._get_keyboard( heading="Enter String to Decode" )
		if ( not vq ): return False, 0
		input = str(vq)
		output = base64.b64decode(vq)
		dialog.ok(AddonTitle, '[COLOR lightskyblue]Encrypted String: [/COLOR]' + input, '[COLOR lightskyblue]Original String: [/COLOR]' + output)

#######################################################################
#				TURN AUTO CLEAN ON|OFF
#######################################################################	

def AUTO_CLEAN_ON_OFF():

    startup_clean = plugintools.get_setting("acstartup")

    if startup_clean == 'true':
        CURRENT = '    <setting id="acstartup" value="true" />'
        NEW     = '    <setting id="acstartup" value="false" />'
    else:
        CURRENT = '    <setting id="acstartup" value="false" />'
        NEW 	= '    <setting id="acstartup" value="true" />'

    HOME         =  xbmc.translatePath('special://userdata/addon_data/plugin.video.tdbwizard')
    for root, dirs, files in os.walk(HOME):  #Search all xml files and replace physical with special
        for file in files:
            if file == "settings.xml":
                 a=open((os.path.join(root, file))).read()
                 b=a.replace(CURRENT, NEW)
                 f = open((os.path.join(root, file)), mode='w')
                 f.write(str(b))
                 f.close()

    xbmc.executebuiltin("Container.Refresh")

#######################################################################
#				TURN WEEKLY AUTO CLEAN ON|OFF
#######################################################################	

def AUTO_WEEKLY_CLEAN_ON_OFF():

    startup_clean = plugintools.get_setting("clearday")

    if startup_clean == '1':
        CURRENT = '    <setting id="clearday" value="1" />'
        NEW     = '    <setting id="clearday" value="0" />'
    if startup_clean == '2':
        CURRENT = '    <setting id="clearday" value="2" />'
        NEW     = '    <setting id="clearday" value="0" />'
    if startup_clean == '3':
        CURRENT = '    <setting id="clearday" value="3" />'
        NEW     = '    <setting id="clearday" value="0" />'
    if startup_clean == '4':
        CURRENT = '    <setting id="clearday" value="4" />'
        NEW     = '    <setting id="clearday" value="0" />'
    if startup_clean == '5':
        CURRENT = '    <setting id="clearday" value="5" />'
        NEW     = '    <setting id="clearday" value="0" />'
    if startup_clean == '6':
        CURRENT = '    <setting id="clearday" value="6" />'
        NEW     = '    <setting id="clearday" value="0" />'
    if startup_clean == '7':
        CURRENT = '    <setting id="clearday" value="7" />'
        NEW     = '    <setting id="clearday" value="0" />'
    if startup_clean == '0':
        CURRENT = '    <setting id="clearday" value="0" />'
        NEW     = '    <setting id="clearday" value="1" />'


    HOME         =  xbmc.translatePath('special://userdata/addon_data/plugin.video.tdbwizard')
    for root, dirs, files in os.walk(HOME):  #Search all xml files and replace physical with special
        for file in files:
            if file == "settings.xml":
                 a=open((os.path.join(root, file))).read()
                 b=a.replace(CURRENT, NEW)
                 f = open((os.path.join(root, file)), mode='w')
                 f.write(str(b))
                 f.close()

    xbmc.executebuiltin("Container.Refresh")