import xbmc, xbmcaddon, xbmcgui, xbmcplugin,os,base64,sys,xbmcvfs
import urllib2,urllib
import extract
import downloader
import re
import time
import common as Common
import plugintools
import installer

AddonTitle="[COLOR ghostwhite]TDB[/COLOR] [COLOR lightsteelblue]Wizard[/COLOR]"
addon_id = 'plugin.video.tdbwizard'
ADDON = xbmcaddon.Addon(id=addon_id)
FANART = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'fanart.jpg'))
ICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon.png'))
WIZARDICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/wizard.png'))
SUPPORT_ICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'resources/art/support.png'))
BASEURL = base64.b64decode(b"aHR0cDovL3RlYW10ZGJidWlsZHMuY28udWsv")
TDB_JARVIS = BASEURL + base64.b64decode(b"YnVpbGRzL3dpemFyZC93aXphcmRfcmVsX2phcnZpcy50eHQ=")
TDB_KRYPTON = BASEURL + base64.b64decode(b"YnVpbGRzL3dpemFyZC93aXphcmRfcmVsX2tyeXB0b24udHh0")
CUSTOM_URL = BASEURL + base64.b64decode(b"YnVpbGRzL3dpemFyZC9jdXN0b20udHh0")
CUSTOM = BASEURL + base64.b64decode(b"YnVpbGRzL3dpemFyZC9jdXN0b21fYnVpbGRzLw==")
youtubelink = base64.b64decode(b"cGx1Z2luOi8vcGx1Z2luLnZpZGVvLnlvdXR1YmUvcGxheS8/dmlkZW9faWQ9")
dialog = xbmcgui.Dialog()

#######################################################################
#					TDB WIZARD BUILD MENU
#######################################################################

def BUILDMENU():

	try:
		xbmc_version=xbmc.getInfoLabel("System.BuildVersion")
		version=float(xbmc_version[:4])
		codename = "Decline"
	
		if version >= 16.0 and version <= 16.9:
			codename = 'Jarvis'
		if version >= 17.0 and version <= 17.9:
			codename = 'Krypton'
	
		if codename == "Jarvis":	
			link=Common.OPEN_URL(BASEURL + base64.b64decode(b'YnVpbGRzL2xpc3RfamFydmlzLnhtbA=='))
			plugins=re.compile('<list>(.+?)</list>').findall(link)
			for match in plugins:
				strul = match
				get = strul.split('(')[0]
				caption=str(strul.split('(')[1].replace(')',''))
				Common.addDir("[COLOR white][B]" + caption + " Builds [/COLOR][/B]",'',83,ICON,FANART,'')
				link = Common.OPEN_URL(get).replace('\n','').replace('\r','')
				match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)".+?escription="(.+?)".+?resh="(.+?)".+?ash="(.+?)".+?outube="(.+?)".+?kin="(.+?)"').findall(link)
				for name,url,iconimage,fanart,version,desc,fresh,hash,youtube,skin in match:
					id=youtubelink+youtube
					description = str(desc + "," + hash + "," + fresh + "," + id + "," + skin)
					Common.addDir(name,url,83,iconimage,fanart,description)
			Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,22,SUPPORT_ICON,FANART,'')
			Common.addItem('[COLOR lightskyblue][B]DO YOU NEED HELP OR SUPPORT?[/B][/COLOR]',BASEURL,22,SUPPORT_ICON,FANART,'')
	
		if codename == "Krypton":	
			link=Common.OPEN_URL(BASEURL + base64.b64decode(b'YnVpbGRzL2xpc3Rfa3J5cHRvbi54bWw='))
			plugins=re.compile('<list>(.+?)</list>').findall(link)
			for match in plugins:
				strul = match
				get = strul.split('(')[0]
				caption=str(strul.split('(')[1].replace(')',''))
				Common.addDir("[COLOR white][B]" + caption + " Builds [/COLOR][/B]",'',83,ICON,FANART,'')
				link = Common.OPEN_URL(get).replace('\n','').replace('\r','')
				match = re.compile('name="(.+?)".+?rl="(.+?)".+?mg="(.+?)".+?anart="(.+?)".+?ersion="(.+?)".+?escription="(.+?)".+?resh="(.+?)".+?ash="(.+?)".+?outube="(.+?)".+?kin="(.+?)"').findall(link)
				for name,url,iconimage,fanart,version,desc,fresh,hash,youtube,skin in match:
					id=youtubelink+youtube
					description = str(desc + "," + hash + "," + fresh + "," + id + "," + skin)
					Common.addDir(name,url,83,iconimage,fanart,description)
			Common.addItem('[COLOR smokewhite]-----------------------------------------------------------[/COLOR]',BASEURL,22,SUPPORT_ICON,FANART,'')
			Common.addItem('[COLOR lightskyblue][B]DO YOU NEED HELP OR SUPPORT?[/B][/COLOR]',BASEURL,22,SUPPORT_ICON,FANART,'')

		if codename == "Decline":
			dialog.ok(AddonTitle, "Sorry we are unable to process your request","[COLOR lightskyblue][I][B]Error: TDB does not support this version of Kodi.[/COLOR][/I][/B]","[I]Your are running: [COLOR lightsteelblue][B]Kodi " + codename + " Version:[COLOR ghostwhite] %s" % version + "[/COLOR][/I][/B][/COLOR]")

	except:
		dialog.ok(AddonTitle, "[COLOR red][B]We have encountered an error whilst trying to connect to the TDB servers. Some functionality in the wizard may be off line but most things like maintenance should still work.[/B][/COLOR]")
		sys.exit(1)

#######################################################################
#						CUSTOM BUILD
#######################################################################

def CUSTOM_BUILD():

	success = 0
	vq = Common._get_keyboard( heading="Please Enter Your Password" )
	if ( not vq ): return False, 0
	title = vq

	link = Common.OPEN_URL(CUSTOM_URL).replace('\n','').replace('\r','')
	match = re.compile('name="(.+?)".+?asskey="(.+?)"').findall(link)
	for name,passkey in match:
		if title==passkey:
			url = os.path.join(CUSTOM, title + '.zip')
			success = 1
			description = "0"
			installer.INSTALL_COMMUNITY(name,url,description)
	
	if success == 0:
		dialog = xbmcgui.Dialog()
		dialog.ok(AddonTitle, "Sorry the password entered was not found.",'[COLOR smokewhite]Thank you for using TDB Wizard[/COLOR]')
	